<?php

class designFunctions
{
	/*---------------------\
	| initialize functions |
	\---------------------*/
	function designFunctions($site,$page)
	{
		$this->DESIGNS  = new SQLiteDatabase("./$site/designs.dbf"); // designs database
		$this->cookie   = "wcms";
		$this->page     = $page;
		$this->site     = $site;
		$this->host     = preg_replace("/^www./","",$_SERVER["HTTP_HOST"]);
		$this->tpl_host = "wfiedler-free-templates.org";
		
		if($_REQUEST['edit'])
		{
			$this->updateDesign($_REQUEST['edit'],$page);
			return;
		}
		if(isset($_REQUEST['add']))
		{
			$this->addDesign($page);
			return;
		}
		$this->showTemplates($page);
	}
	
        /*---------------------------\
        | display wfiedler templates |
        \---------------------------*/
	function showTemplates($page)
	{
		$DESC   = $_REQUEST['DESC'];
		$AUTHOR = $_REQUEST['AUTHOR'];
		
		$max  = $_REQUEST['max'];
		if(!$max)  $max = 9;

		$pnum = $_REQUEST['pnum'];
		if($_REQUEST['First'])	  $pnum = 0;
		elseif($_REQUEST['Next']) $pnum = $_REQUEST['next'];
		elseif($_REQUEST['Prev']) $pnum = $_REQUEST['prev'];
		elseif($_REQUEST['Last']) $pnum = $_REQUEST['last'];
		
		$where = "";
		if($_REQUEST['DESC'])
		{
			$where = "WHERE Desc LIKE '%$DESC%'";
		}
		if($_REQUEST['AUTHOR'])
		{
			if($where) $where .= "AND ";
			else $where = "WHERE ";
			$where .= "Author='$AUTHOR'";
		}
		
		$q = @$this->DESIGNS->query("SELECT COUNT(*) FROM OST $where");
		if($q===FALSE)
		{
			$this->DESIGNS->query(
				"CREATE TABLE OST ".
				"( id INTEGER PRIMARY KEY, Design CHAR(80), Author CHAR(80), ".
				"DID INTEGER, Desc TEXT, Theme CHAR(80), Downloads INTEGER, mdate INTEGER)");
			$q = @$this->DESIGNS->query("SELECT COUNT(*) FROM OST $where");
		}
		list($NumItems) = $q->fetch();
		
		if(!$pnum) $pnum = 0;
		
		$rnum = $pnum * $max;
		if($rnum >= $NumItems) $rnum = $NumItems - $max;

		$prev = $pnum - 1;
		$next = $pnum + 1;
		$last = (int)($NumItems / $max);
		if($next * $max >= $NumItems)
		{
			$prev = $next - 3;
			$next = 0;
		}
		if($prev<0) $prev = 0;
		if($pnum>$last) $pnum = $last;
		
		$links = "<div class='pagination'>\n".
			 "<form method='post' action='index.php'>\n".
			 "<input type='hidden' name='p' value='$page' />\n".
			 "<input type='hidden' name='max' value='$max' />\n".
			 "<input type='hidden' name='next' value='$next' />\n".
			 "<input type='hidden' name='prev' value='$prev' />\n".
			 "<input type='hidden' name='last' value='$last' />\n".
			 "<input type='hidden' name='DESC' value='$DESC' />\n".
			 "<input type='hidden' name='AUTHOR' value='$AUTHOR' />\n".
			 "<input class='button' type='submit' name='First' value='First' />\n".
			 "<input class='button' type='submit' name='Next' value='Next' />\n".
			 "<input class='button' type='submit' name='Prev' value='Prev' />\n".
			 "<input class='button' type='submit' name='Last' value='Last' />\n".
			 "Total Number of Templates: $NumItems - <b>Page $pnum of $last</b></div>\n";

		echo "$links<div id='thumbs'>\n<ul>";
		$password = @file_get_contents("$this->site/password");
		$designer = trim(@file_get_contents("$this->site/designer"));

		$q = $this->DESIGNS->query("SELECT * FROM OST $where ORDER BY mdate DESC LIMIT $rnum,$max");
		$content = "";
		while( $q->valid() )
		{
			list($ID,$design,$author,$did,$desc,$theme,$downloads,$mdate) = $q->current();
			
			$q->next();
			$desc = stripslashes ( $desc );
			$desc = preg_replace("/<br><br>|<br>|<br \/><br \/>|<br \/>/"," -- ",$desc);
			$desc = strip_tags($desc,"");
			$desc = preg_replace("/\'/","&#39;",$desc);
			$demo = "";
			if (is_dir("./$design/") || is_dir("./$author"."_$design/"))
			{
				$site = $design;
				if(is_dir("./$author"."_$design/")) $site = $author."_$design";
				$demo = " - <a href='?site=$site' title='Go to site: $design'>Demo</a>";
			}
			$content .= "<li style='border-bottom: 1px solid #999; padding-bottom: 16px;'>\n".
				    "<b>$design</b><br /><a title='$desc' href='./templates/$author/$design/' class='preview'>".
				    "<img class='thumbs' src='./templates/$author/$design/thumb.jpg' ".
				    "alt='thumb nail image $design --- missing!' /></a><br />".
				    "<img class='icon' src='images/zoomin.png' alt='Preview' />".
				    "<a title='Preview $design' href='./templates/$author/$design/' class='preview'>Preview</a> $demo<br />\n";

			if($this->site=="public")
			{
				if($_COOKIE[$this->cookie])
				{
					if($_COOKIE['mysite']=="main" || $_COOKIE['mysite']==$this->site)
					{
						$content .= "<img class='icon' src='images/redo.png' alt='Update' />".
							$this->popupWindow("userFunctions.php?udef=templates&edit=$ID&s=public",450,500,"Update","Update Description: $design").
							$this->popupWindow("./codes/updatetemplate.php?edit=$design&site=$author",980,600,"Theme","Update Theme: $design");
					}
					elseif( file_exists("./templates/$author/$design.php") )
					{
						$content .= "<img class='icon' src='images/redo.png' alt='Update' />".
							$this->popupWindow("userFunctions.php?udef=templates&designer=$author&tpl=$design",450,200,"Use this theme","Use this theme: $design");
					}
					else
					{
						$content .= "<img class='icon' src='images/redo.png' alt='Update' />$author";
					}
				}
				else $content .= "<b>Designer:</b> <a href='./$author/'>$author</a>";
			}
			elseif($_COOKIE[$this->cookie])
			{
				if($_COOKIE[$this->cookie]==$password || $_COOKIE['mysite']=="main")
				{
					$content .= "<img class='icon' src='images/redo.png' alt='Update' />".
						$this->popupWindow("./codes/updatetemplate.php?edit=$design&site=$author",980,600,"Theme","Update Theme: $design").
						$this->popupWindow("userFunctions.php?udef=templates&edit=$ID&p=$page&s=$this->site",450,500,"Description","Update Description: $design");
				}
				elseif( file_exists("./templates/$author/$design.php") )
				{
					$content .= $this->popupWindow("userFunctions.php?udef=templates&designer=$author&tpl=$design",450,200,"Use this theme","Use this theme: $design");
				}
			}
			elseif( file_exists("./templates/$author/$design.zip") )
			{
				$content .= "<img class='icon' src='images/download.png' alt='Download' />".
					    "<a href='?download=$ID&p=$this->page' title='Download $design'>Download</a> ($downloads)\n";
			}
			else	$content .= "&#9658;  Download NA";
			$content .= "</li>\n";
		}
		echo "$content</ul></div>\n\n $links \n".
				"<div class='pagination'><input class='button' type='submit' value='Go to page: ' /> ".
				"<input name='pnum' value='$pnum' style='width: 30px;' /><br />".
				"Max per page: <input name='max' value='$max' style='width: 30px;' /> &nbsp; &nbsp; &nbsp; ".
				"Author: <input name='AUTHOR' value='$AUTHOR' style='width: 200px;' /><br />\n".
				"Description: <input name='DESC' value='$DESC' style='width: 400px;' />". 
				" <input class='button' type='submit' value='Set' /></form> ";
		if($_COOKIE[$this->cookie]==$password)
		{
			echo "<br /><br /><img class='icon' src='images/add.png' alt='Add Template' />".
				$this->popupWindow("userFunctions.php?udef=templates&add&p=$page",450,510,"Add Template","Add new template");
		}

		echo "</div>";
	}
	
        /*--------------\
        | update design |
        \--------------*/
	function updateDesign($id,$page)
	{
		if (!$_COOKIE[$this->cookie] && !$_REQUEST['host'])
		{
			echo "<div class='error'>You must login first before you can use this function!</div>";
			return;
		}
		if($_POST['Delete'])
		{
			$q = $this->DESIGNS->query("SELECT id,Author,Design FROM OST WHERE id ='$id'");
			list($idnum,$this->author,$this->design) = $q->fetch();
			if(!$idnum)
			{
				echo "<div class='error'>Record $id not in database!</div>";
			}
			else
			{
				$q = $this->DESIGNS->query("DELETE FROM OST WHERE id ='$id'");
				echo "<div class='info'>Record $id deleted from the database!</div>";
				$this->deleted = $id;
			}
			return;
		}
		if($id=="NULL")
		{
			$author = sqlite_escape_string(stripslashes($_POST['author']));
			$design = sqlite_escape_string(stripslashes($_POST['design']));
			
			$q = @$this->DESIGNS->query("SELECT id FROM OST WHERE Author='$author' AND Design='$design'");
			list($id) = $q->fetch();

			if(!$id)
			{
				$desc  = sqlite_escape_string(stripslashes($_POST['desc']));
				$mdate = $_POST['mdate'];
				$this->DESIGNS->query("INSERT INTO OST VALUES(NULL,'$design','$author','','$desc','NULL','0','$mdate')");
				echo "<div class='info'>$design for $author added</div>";
				$content = $_POST['content'];
				if($content)
				{
					$content = preg_replace("/\|/","\0xff ",$content)."\n";
					$this->saveActivity("design",$content);
					$this->saveActivity("all","design\0xff $content");
				}
				if (!is_dir("./templates/$author/$design/"))
				{
					$data = @file_get_contents("http://".$_POST['host']."/templates/$author/$design.zip");
					$file = @fopen("./templates/$author/$design.zip", "w");
					if($file);
					{
						fwrite($file, $data);
						fclose($file);

						echo install($author,$design,0);
					}
				}
				return;
			}
		}
		if($_POST['author'])
		{
			$author = sqlite_escape_string(stripslashes($_POST['author']));
			$design = sqlite_escape_string(stripslashes($_POST['design']));
			$desc   = sqlite_escape_string(stripslashes($_POST['desc']));
			$mdate  = $_POST['mdate'];
			
			$q = $this->DESIGNS->query("UPDATE OST SET Author='$author',Design='$design',Desc='$desc',mdate='$mdate'".
				" WHERE id ='$id'");
			
			echo "<div class='info'>$design for $author updated</div>";
			
			return;
		}
		$q = $this->DESIGNS->query("SELECT * FROM OST WHERE id ='$id'");
		list($idnum,$design,$author,$did,$desc,$theme,$downloads,$mdate) = $q->fetch();
		if(!$idnum)
		{
			echo "<div class='error'>Record $id not in database!</div>";
			return;
		}
		
		if( file_exists("./templates/$author/$design.php") )
		{
			echo "<p><a href='userFunctions.php?udef=templates&designer=$author&tpl=$design'>".
				"Click here to use this template for theme</a></p>";
		}
		if($_COOKIE["mysite"]!="main" && $_COOKIE["mysite"]!=$this->site)
		{
			echo "<div class='error'>Sorry, you have no permission to update this template!</div></div></body></html>\n";
			exit;
		}
		list($second,$minute,$hour,$day,$month,$year) = localtime(time());
                $date    = sprintf("%d/%02d/%02d %02d:%02d",$year+1900,$month+1,$day,$hour,$minute);
		$host    = $_SERVER["HTTP_HOST"];
		$DESC    = preg_replace("/\'/","&#39;",$desc);
		$uname   = $_COOKIE['uname'];
		$content = "$date|$this->host|$uname|added template:|$author|$design|http://$this->host/?site=$this->site&p=$page";

		echo "<h3>Update Design </h3>\n".
			"<form method='post' action='userFunctions.php'>\n".
			"<input type='hidden' name='udef' value='templates' />\n".
			"<input type='hidden' name='p' value='$page' />\n".
			"<input type='hidden' name='s' value='$this->site' />\n".
			"<input type='hidden' name='edit' value='$id'  />\n".
			"<p><strong>Author:</strong> <input name='author' value='$author' style='width: 300px;' /></p>\n".
			"<p><strong>Design:</strong> <input name='design' value='$design' style='width: 300px;' /></p>\n".
			"<p><strong>Date:</strong> <input name='mdate' value='$mdate' style='width: 100px;' /></p>\n".
			"<p><strong>Description:</strong><br />\n".
			"<textarea name='desc' style='width: 100%;height: 130px;'>$desc</textarea></p>\n".
			"<p><button class='button' type='submit' name='Save' value='Save' >Update</button>&nbsp; &nbsp; &nbsp; \n".
			"<button class='button' onclick='window.close()'>Cancel</button></p>\n".
			"<p><button class='button' type='submit' name='Delete' value='Delete' style='color:#c00' ".
			"title='WARNING: deleted design cannot be recovered!'> Delete this design ($id)</button></form>\n".
			"<form method='post' action='http://$this->tpl_host/userFunctions.php'>\n". 
			"<input type='hidden' name='udef' value='templates' />\n".
			"<input type='hidden' name='edit' value='NULL' />\n".
			"<input type='hidden' name='host' value='$this->host' />\n".
			"<input type='hidden' name='s' value='public' />\n".
			"<input type='hidden' name='design' value='$design' />\n".
			"<input type='hidden' name='author' value='$author' />\n".
			"<input type='hidden' name='desc' value='$DESC' />\n".
			"<input type='hidden' name='mdate' value='$mdate' />\n".
			"<input type='hidden' name='content' value='$content' />\n";
		
		
		if($this->site!="public") echo "<input type='submit' value='Click here to update listing at Community site' style='width: 100%;' />\n";

		echo "</form>\n</div></body></html>\n";
		exit;
	}

        /*-----------\
        | add design |
        \-----------*/
	function addDesign($page)
	{
		$this->author = $_REQUEST['author'];
		if(!$this->author) $this->author = file_get_contents("$this->site/designer");
		$this->design = $_REQUEST['design'];
		$this->zfile  = $_FILES['zfile']['name'];
		$mdate = $_REQUEST['mdate'];
		if(!$mdate)
		{
			$mdate = date("YmdHi");
		}
		$this->desc = $desc = stripslashes($_REQUEST['desc']);
		if(!$this->design || !$this->author ||!$this->zfile)
		{
			if($_POST['desc']) $errmsg = "<div class='error'>Missing required information</div>";
			else $errmsg = "";
			$this->inputForm($this->author,$this->design,$desc,$this->zfile,$errmsg,$page,$_POST['mdate']);
			echo "</div></body></html>\n";
			exit;
		}
		$des = sqlite_escape_string($this->design);
		$aut = sqlite_escape_string($this->author);
		$q = @$this->DESIGNS->query("SELECT id,Design,Author FROM OST WHERE Author='$aut' AND Design='$des'");
		list($id,$des,$aut) = $q->fetch();
		if($id)
		{
			echo "<p><div class='error'>$des by $author was already addeded ($id)</div></p>";
			return;
		}
		/*if($_FILES['zfile']['type']!="application/zip")
		{
			$errmsg = "<div class='error'>File must be type <b>zip</b></div>";
			$this->inputForm($this->author,$this->design,$desc,$this->zfile,$errmsg,$page);
			return;
		}*/
		$design = sqlite_escape_string($this->design);
		$desc   = sqlite_escape_string($desc);
		$author = sqlite_escape_string($this->author);
				
		$q = $this->DESIGNS->query("INSERT INTO OST VALUES(NULL,'$design','$author','','$desc','NULL','0','$mdate')");

		echo "<div class='info'>$design for $author added.</div>";

		$this->desc = preg_replace("/\'/","&#39;",$this->desc);
		$content = $this->designActivity("added template:",$this->author,$this->design,
				      "http://$this->host/?site=$this->site&p=$this->page",$this->desc,$mdate);

		$content = preg_replace("/\|/","\0xff ",$content)."\n";
		$this->saveActivity("design",$content);
		$this->saveActivity("all","design\0xff $content");

		return;
	}
		
        /*----------------------\
        | add design input form |
        \----------------------*/
	function inputForm($author,$design,$desc,$zfile,$errmsg,$page,$mdate)
	{
		if(!$desc)
		{
			$date = date ("F jS, Y",time());
			$desc = "A free CSS website template from $this->site.<br /><br />\n".
				  "<b>W3C:</b> XHTML 1.0 Transitional<br />\n".
				  "<b>License:</b> Creative Commons<br />\n".
				  "<b>Added:</b> $date<br>\n<b>Tags:</b>\n";
		}
		if(!$mdate) $mdate = date("YmdHi");
		echo "<h3>Add Template</h3>$errmsg".
			 "<form method='post' action='userFunctions.php' enctype='multipart/form-data'>".
			 "<input type='hidden' name='udef' value='templates' />".
			 "<input type='hidden' name='add' value='design' />".
			 "<input type='hidden' name='p' value='$page' />".
			 "<p><strong>* Author:</strong> <input type='text' name='author' value='$author' style='width: 300px;' /></p>".
			 "<p><strong>* Design:</strong> <input type='text' name='design' value='$design' style='width: 300px;' /></p>".
			 "<p><strong> Date:</strong> <input type='text' name='mdate' value='$mdate' style='width: 100px;' /></p>".
			 "<p><strong>Description:</strong><br /><textarea name='desc' style='width: 100%;height: 130px;'>$desc</textarea></p>".
			 "<p><strong>* Zip File:</strong> <input name='zfile' type='file' />".
			 "<p><strong>* Required</p>".
			 "<p><button class='button' type='submit' name='Save' value='Save' >Add</button> &nbsp; &nbsp; &nbsp; ".
			 "<button class='button' onclick='window.close()'>Cancel</button></p></form>";
		return;
	}

        /*-----------------\
        | append Activity  |
        \-----------------*/
        function designActivity($action,$author,$design,$link,$desc,$mdate)
        {
		list($second,$minute,$hour,$day,$month,$year) = localtime(time());
                $date = sprintf("%d/%02d/%02d %02d:%02d",$year+1900,$month+1,$day,$hour,$minute);

		$uname   = $_COOKIE['uname'];
		$content = "$date|$this->host|$uname|$action|$author|$design|$link";

		echo "<form method='post' action='http://wfiedler-free-templates.org/userFunctions.php'>\n".
			"<input type='hidden' name='udef' value='activity' />\n".
			"<input type='hidden' name='type' value='design' />\n".
			"<input type='hidden' name='host' value='$this->host' />".
			"<input type='hidden' name='mdate' value='$mdate' />".
			"<input type='hidden' name='design' value='$design' />\n".
			"<input type='hidden' name='author' value='$author' />\n".
			"<input type='hidden' name='desc' value='$desc' />\n".
			"<input type='hidden' name='content' value='$content' />\n".
			"<input type='submit' value='Click here to notify Community' />\n</form>";
		
		return $content;
        }
	
        /*---------------\
        | save activity  |
        \---------------*/
        function saveActivity($type,$content)
        {		
		$data = explode("\n",@file_get_contents("./public/$type"));

		$file = @fopen("./public/$type", "w");
		if(!$file) return;
		$content = preg_replace("/\'/","&#39;",$content);
		fwrite($file, $content);
		for($ix=0;$ix<25;$ix++)
		{
			fwrite($file,$data[$ix]."\n");
		}
		fclose($file);
        }

        /*--------------\
        | popup window  |
        \--------------*/
        function popupWindow($url,$width,$height,$name,$title)
        {
		return "<a href='#' onclick=\"OpenNewWindow('$url','$width','$height','Loading');\" title='$title'> $name </a>";
        }

}
?>

