<?php
   
class cPanel

{

	/*---------------------------\
	| initialize content objects |
	\---------------------------*/
	function cPanel($site)
	{
		$this->host   = "http://".$_SERVER['HTTP_HOST'];
		$this->cookie = 'wcms';	// cookie name
		$this->site   = $site;
		$this->pass_admin  = @file_get_contents("$this->site/password");
		$this->pass_member = @file_get_contents("$this->site/member");

		$this->language = $_REQUEST['l'];
		if(!$this->language )
		{
			$language = trim(@file_get_contents("$this->site/language"));
			if($language)
			{
				$this->language = $_SESSION['language'];
				if(!$this->language)
				{
					$this->language = $language;
					$_SESSION['language'] = $this->language;
				}
			}
		}
		if( $this->language=='en' ) $this->language = "";
		if($this->language)
		{
			if(! is_dir("$this->site/$this->language"))
			{
				if($_COOKIE[$this->cookie]==$this->pass_admin)
				{
					if(!@mkdir("$this->site/$this->language", 0755))
					{
						echo "<div class='error'>*** FATAL *** unable to create language folder!</div>";
						exit;
					}
					copy ( "$this->site/menus" , "$this->site/$this->language/menus" );
					copy ( "$this->site/settings" , "$this->site/$this->language/settings" );
					$_SESSION['language'] = $this->language;
					$this->content = "Language folder $this->language created";
					
					$this->miscActivity("created","language",$this->language,"?site=$this->site&l=$this->lanuage");
					
					require("./templates/cpanel.php");
					exit;
				}
				else
				{
					$_SESSION['language'] = "";
					$this->language = "";
				}
			}
			else $this->language = "/$this->language";
		}
		
		if($_REQUEST['menu']) $this->updateMenuItem($_REQUEST['menu']);
		
		if($_REQUEST['dn']=="edit") $this->updateDownload();
		
		if(isset($_REQUEST['group']))
		{
			$this->addPage($_REQUEST['group']);
			header("Location: ?menus&g=".$_REQUEST['group']);
			exit;
		}
		if(isset($_REQUEST['add']))
		{
			$this->addSubPage($_REQUEST['add']);
			header("Location: ?menus&g=$this->group");
			exit;
		}
		if($_REQUEST['delete'])
		{
			$this->saveMenuItem($_REQUEST['delete']);
			header("Location: ?menus&g=".$_REQUEST['g']);
			exit;
		}
		if($_REQUEST['show'])
		{
			switch($_REQUEST['show'])
			{
				case 'listing' : $this->sitesListing();
						 break;
				case 'map': $this->siteMap();
					    break;
				default : $this->content = "<div class='info'>This function is under construction...</div>";
			}
			require("./templates/cpanel.php");
			exit;
		}
		if(!$this->pass_admin)
		{
			$this->pass_admin = crypt("admin",$this->site);
			$file = @fopen("$this->site/password", "w");
			if(!$file)
			{
				$this->content .= "<div class='error'>*** FATAL *** unable to open 'password' file!</div>".
					"<p>Please make sure read/write permissions are enabled!</p>";
				return;
			}
			fwrite($file, $this->pass_admin);
			fclose($file);
			
		}
		if(!$this->pass_member)
		{
			$this->pass_member = crypt("member",$this->site);
			$file = @fopen("$this->site/member", "w");
			if(!$file)
			{
				$this->content .= "<div class='error'>*** FATAL *** unable to open 'password' file!</div>".
					"<p>Please make sure read/write permissions are enabled!</p>";
				return;
			}
			fwrite($file, $this->pass_member);
			fclose($file);
			
		}

		if($_COOKIE['mysite']!=$this->site || $_COOKIE[$this->cookie]!=$this->pass_admin && $_COOKIE[$this->cookie]!=$this->pass_member)
		{
			$this->login();
			require("./templates/cpanel.php");
			exit;
		}
				
		if($_REQUEST['album'])
		{
			$_SESSION['album'] = $_REQUEST['album'];			
		}
		if($_SESSION['album'])
		{
			if(! is_dir("$site/".$_SESSION['album'])) $_SESSION['album'] = "";
		}
				
		$this->getSettings();	// get settings

		require("./templates/cpanel.php");
	}

	/*------------\
	| login stuff |
	\------------*/
	function login()
	{
		if (isset($_POST['sub'])) return $this->loginSubmitted();

		$this->getLoginForm("");
	}
	
	/*----------------\
	| login submitted |
	\----------------*/
	function loginSubmitted()
	{
		$this->submitted_pass = crypt($_POST['password'],$this->site);
		if($_POST['user'] == "admin" && $this->submitted_pass!=$this->pass_admin)
		{
			$this->getLoginForm("Wrong Password!");
			return;
		}
		elseif($_POST['user'] == "member" && $this->submitted_pass!=$this->pass_member)
		{
			$this->getLoginForm("Wrong Password!");
			return;
		}
		setcookie($this->cookie,$this->submitted_pass,$this->expirytime);
		setcookie("user",$_POST['user'],$this->expirytime);
		setcookie("mysite",$this->site,$this->expirytime);
		
		list($title,$slogan,$copyright,$meta,$email,$editor,$uname) =
			explode("^^^",@file_get_contents("$this->site$this->language/settings"));
		if(!$uname) $uname = $this->site;
		setcookie("uname",$uname,$this->expirytime);
		
		header('Location: ./');
		exit;
	}
	
	/*-------------------\
	| display login page |
	\-------------------*/
	function getLoginForm($msg)
	{
		if($_REQUEST['user']=="admin") $admin = "checked";
		else $member = "checked";
		
		$this->content = "<form action='admin.php' method='POST'><h2>Password</h2>".
				 "<input type='hidden' name='sub' value='sub'/>".
				 "<input type='password' name='password'/> <b style='color: #c00;'>$msg</b><br />".
				 "<input style='width: 10px;' type='radio' name='user' value='admin' $admin /> Admin ".
				 "<input style='width: 10px;' type='radio' name='user' value='member' $member /> Member<br />".
				 "<input class='button' type='submit' value='Login'/></form>".
				 "<a href='./?set=clear'>Cancel Operation</a></form><br/>".
				 "<a href='?show=listing'>Sites Listing</a>";
	}

	/*-------------\
	| get settings |
	\-------------*/
	function getSettings()
	{
		if($_REQUEST['tpl']) return $this->editTemplate($_REQUEST['tpl']);
			
		$this->show_hide = "<style>.show_hide {\nmargin: 16px 0;\n}\ndiv.textbox {\n}\n.textbox p {\n}\n</style>\n".
				   "<script type='text/javascript'>\n".
				   "$(document).ready(function() {\n".
				   "$('#textbox').hide();\n".
				   "$('a.comment').click(function() {\n".
				   "var id = $(this).attr('id');\n".
				   "$('#textbox' + id).toggle('fast');\n".
				   "return false;\n".
				   "});\n});\n</script>".
				   "<script type='text/javascript'>\n".
				   "function SelectAll(id)\n{\n".
				   "document.getElementById(id).focus();\n".
				   "document.getElementById(id).select();\n}\n".
				   "</script>";
		if(isset($_REQUEST['edit']))
		{
			list($title,$slogan,$copyright,$meta,$email,$editor,$uname) =
			explode("^^^",@file_get_contents("$this->site$this->language/settings"));
			$editor = strtolower($editor);
			if($editor=="tinymce") return $this->editPageTinyMCE($_REQUEST['type'],$_REQUEST['edit']);
			elseif($editor=="ckeditor") return $this->editPageCKEditor($_REQUEST['type'],$_REQUEST['edit']);
			if($_COOKIE['user']=="member")
			{
				if(is_dir("ckeditor")) return $this->editPageCKEditor($_REQUEST['type'],$_REQUEST['edit']);
				if(is_dir("tinymce"))  return $this->editPageTinyMCE($_REQUEST['type'],$_REQUEST['edit']);
			}
			return $this->editPage($_REQUEST['type'],$_REQUEST['edit']);
		}
		if(isset($_REQUEST['Site']))		return $this->updateSite();
		if(isset($_REQUEST['menus']))		return $this->updateMenus();
		if(isset($_REQUEST['sections']))	return $this->updateSections();
		if(isset($_REQUEST['settings']))	return $this->updateSettings();
		if(isset($_REQUEST['files']))		return $this->manageFiles();
		if(isset($_REQUEST['templates']))	return $this->manageTemplates();
		
		if(isset($_REQUEST['albums']) || isset($_REQUEST['album']) || $_REQUEST['dlt'] || $_REQUEST['update']) return $this->updateAlbums();
		
		$this->content .= "<h2>w-CMS Site Managment</h2><ul>".
				  "<li><a href='?Site'>Sites Listing</a> <span style='color: #c00;'>+</span> - Add/Remove Site</li>".
				  "<li><a href='?settings=update'>Settings</a> <span style='color: #c00;'>*</span> - Update Site Settings</li>".
				  "<li><a href='?settings=themes'>Themes</a> <span style='color: #c00;'>*</span> - Update Theme Selection List</li>".
				  "<li><a href='?settings=languages'>Languages</a> <span style='color: #c00;'>*</span> - Update Language Selection List</li>".
				  "<li><a href='?settings=downloads'>Downloads</a> <span style='color: #c00;'>*</span> - Update Downloads Selection List</li>".
				  "<li><a href='?settings=password'>Password</a> - Change Password</li>".
				  "<li><a href='?menus'>Menus</a> <span style='color: #c00;'>*</span> - Update Menus List</li>".
				  "<li><a href='?sections'>Sections</a> <span style='color: #c00;'>*</span> - Update Section Titles</li>".
				  "<li><a href='?albums'>Albums Listing</a> <span style='color: #c00;'>*</span> - Manage Photo Albums</li>".
				  "<li><a href='?files'>Upload Files</a> <span style='color: #c00;'>*</span> - File Management</li>".
				  "</ul><br /><p><span style='color: #c00;'>+</span> Required login as <b>admin</b> in <b>Main</b><br />".
				  "<span style='color: #c00;'>*</span> Required login as <b>admin</b></p>";
	}
	
        /*------------\
        | update site |
        \------------*/
	function updateSite()
	{
		$this->sub_menu = "<li><a href='?Site'>Display</a></li>".
				  "<li><a href='?Site=update'>Update</a></li>";
		
		if(!$_REQUEST['Site']) return $this->sitesListing();
		
		if($this->site!="main")
		{
			$this->content .= "<p class='info'>You must log into your main site to use this operation.</p>";
			return;
		}
		if($_COOKIE['user']!="admin")
		{
			$this->content .= "<p class='info'>You must login as <b>admin</b> to use this operation.</p>";
			return;
		}
		if($_POST['newsite'])
		{
			$newsite = preg_replace("'/'","_",$_POST['newsite']);
			$this->createFolder($newsite,$_POST['desc'],"sites");

			$this->miscActivity("created","site",$newsite,"?site=$newsite");

			$this->sitesListing();
			return;
		}
		if($_POST['remove'])
		{
			$folder = $_POST['remove'];
			$this->removeFolder("sites",$folder);
			
			$content = "";
			$items   = explode("\n",@file_get_contents("sites"));
			$num     = count($items);
			for($ix=0;$ix<$num;$ix++)
			{
				list($name,$desc) = explode("|",$items[$ix]);
				if($name==$folder ||!$name) continue;
				$content .= "$name|$desc\n";
			}
			$file = @fopen("sites", "w");
			fwrite($file, $content);
			fclose($file);
			
			$this->sitesListing();
			return;
		}
		$sites  = explode("\n",@file_get_contents("sites"));
		$nsites = count($sites);
		$this->content .= "<div id='settings'><form action='admin.php' method='post'>".
				"<input type='hidden' name='Site' value='update' />".
				"<h2>Update Site</h2>".
				"<div class='left'>
				<p>Site Name:</p>
				<p>Description:</p>
				</div>
				<div class='right'>
				<p><input name='newsite' value='' /></p>".
				"<p><input name='desc' value='' /></p>".
				"<input style='width: auto;' class='button' type='submit' value='Add' /><br />".
				"<select name='remove'> <option value=''>SELECT</option>";
		for($ix=0;$ix<$nsites;$ix++)
		{
			list($name) = explode("|",$sites[$ix]);
			if(!$name) continue;
			$this->content .= "<option value='$name'>$name</option>";
		}
		$this->content .= "</select> <input style='width: auto;' class='button' type='submit' value='Remove' title='Remove selected Site' /></form>".
				  "<div class='info'>WARNING: Site removed CANNOT be recovered!</div></div></div>";

	}
	
        /*--------------\
        | sites listing |
        \--------------*/
	function sitesListing()
	{
		$this->content .= "<h2>Sites Listing</h2><ul><li><a href='./main'>main</a> - Main site</li>";
		
		$sites  = explode("\n",@file_get_contents("sites"));
		$nitems = count($sites);

		for($ix=0;$ix<$nitems;$ix++)
		{
			list($name,$desc) = explode("|",$sites[$ix]);
			if(!$name) continue;
			$this->content .= "<li><a href='./$name'>$name</a> - $desc</li>";
		}
		$this->content .= "</ul>";
	}
				
        /*-------------\
        | manage files |
        \-------------*/
	function manageFiles()
	{
		if($_COOKIE['user']!="admin")
		{
			$this->content .= "<p class='info'>You must login as <b>admin</b> to use this operation.</p>";
			return;
		}
		$this->sub_menu = "<li><a href='?files'>Folders</a></li>".
				  "<li><a href='?files=folers'>Update</a></li>".
				  "<li><a href='?files=upload'>Upload</a></li>";

		if($_REQUEST['files'] =="upload")   return $this->uploadFiles();
		if($_REQUEST['files'] =="update")   return $this->updateFile($_REQUEST['file']);
		if($_REQUEST['files'] =="listing")  return $this->filesListing($_REQUEST['folder']);
		if($_REQUEST['files'] =="delete")   return $this->deleteFile($_REQUEST['file']);

		if(!$_REQUEST['files'])  return $this->dirListing();
		
		if($_POST['newfolder'])
		{
			if (!is_dir("$this->site/files/")) @mkdir("$this->site/files/", 0755);

			$newfolder = preg_replace("'/'","_",$_POST['newfolder']);
			if($this->createFolder("$this->site/files/$newfolder/",$_POST['desc'],"file")) return;
			
			$file = @fopen("$this->site/folders", "a");
			fwrite($file, "$newfolder|".$_POST['desc']."\n");
			fclose($file);
			
			$this->content .= "<div class='success'>Folder $newfolder created!</div>";
			$this->dirListing();
			return;
		}
		if($_POST['remove'])
		{
			$this->removeFolder("folders","$this->site/files/".$_POST['remove']);
			
			$content = "";
			$items   = explode("\n",@file_get_contents("$this->site/folders"));
			$num     = count($items);
			for($ix=0;$ix<$num;$ix++)
			{
				list($name,$desc) = explode("|",$items[$ix]);
				if($name==$_POST['remove'] || !$name) continue;
				$content .= "$name|$desc\n";
			}
			$file = @fopen("$this->site/folders", "w");
			fwrite($file, $content);
			fclose($file);
			
			$this->dirListing();
			return;
		}
		$folders  = explode("\n",@file_get_contents("$this->site/folders"));
		$nitems = count($folders);
		$this->content .= "<div id='settings'><form action='admin.php' method='post'>".
				  "<input type='hidden' name='files' value='folders' />".
				  "<h2>Update Folders</h2>".
				  "<div class='left'>
				  <p>Folder Name</p>
				  <p>Description</p>
				  </div>
				  <div class='right'>
				  <input name='newfolder' value='' />".
				  "<input name='desc' value='' /><br />".
				  "<input style='width: auto;' class='button' type='submit' value='Add' /><br />".
				  "<select name='remove'><option value=''>SELECT</option>";
		for($ix=0;$ix<$nitems;$ix++)
		{
			list($name) = explode("|",$folders[$ix]);
			if(!$name) continue;
			$this->content .= "<option value='$name'>$name</option>";
		}
		$this->content .= "</select> <input style='width: auto;' class='button' type='submit' value='Remove' title='Remove selected Folder' /></form><br />".
				  "<div class='info'>WARNING: Folder removed CANNOT be recovered!</div></div></div>";
	}
	
        /*---------------\
        | folder listing |
        \---------------*/
	function dirListing()
	{
		$this->content .= "<h2>Folders Listing</h2>";
		
		$folders = explode("\n",@file_get_contents("$this->site/folders"));
		$nitems  = count($folders);

		for($ix=0;$ix<$nitems;$ix++)
		{
			list($folder,$desc) = explode("|",$folders[$ix]);
			if(!$folder) continue;
			$this->content .= "<b>$folder</b> - $desc<br />";
			
			$files  = explode("\n",@file_get_contents("$this->site/files/$folder/files"));
			$nfiles = count($files);
			for($jx=0;$jx<$nfiles;$jx++)
			{
				list($fname,$desc) = explode("|",$files[$jx]);
				if(!$fname) continue;
				$this->content .= "\n&nbsp; &nbsp; &nbsp; &#124;-- ".
					"<a href='?files=delete&file=$this->site.$folder.$jx' title='delete this file'>".
					"<img src='images/delete.png' title='Delete this file: $fname' alt='Delete' /></a>--".
					"<a href='$this->site/files/$folder/$fname' title='Display $fname'>$fname</a>--[ ".
					"$desc <a href='?files=update&file=$this->site.$folder.$jx'>".
					" <img src='images/pencil.png' title='Edit description: $fname' height='20' alt='Edit' /></a>]<br />";
			}
			$this->content .= "\n<br />";
		}
		$this->content .= "<br />";
	}
	
        /*-------------\
        | upload files |
        \-------------*/
	function uploadFiles()
	{
		$files = trim(@file_get_contents("$this->site/folders"));
		if($files=="")
		{
			$this->content .= "<div class='info'>You must create a folder before you can use this function!</div>";
			return;
		}
		if($_POST['files'])
		{
			if($_POST['folder']) $this->saveFiles($_POST['folder']);
			else $this->content .= "<div class='info'>You must select a folder for this function!</div>";
		}

		$files  = explode("\n",$files);
		$nitems  = count($files);
		
		$name = $selected = $_SESSION['folder'];
		if(!$name)
		{
			list($name) = explode("|",$files[0]);
			if(!$name) $selected = "SELECT";
			else $selected = $name;
		}
		$this->content .= "\n<form class='P10' action='admin.php' method='post' enctype='multipart/form-data'>".
				  "\n<input type='hidden' name='files' value='upload' />".
				  "\n<h2>Upload Files</h2>".
				  "\n<p><b>Folder:</b> <select name='folder'><option value='$name'>$selected</option>";
		for($ix=0;$ix<$nitems;$ix++)
		{
			list($name) = explode("|",$files[$ix]);
			if(!$name) continue;
			$this->content .= "<option value='$name'>$name</option>";
		}
		$this->content .= "</select></p><p>".
				  "\n<div id='settings'>".
				  "\n<div class='left'>".
				  "\n<p>Files</p>".
				  "\n</div>".
				  "\n<div class='right'>".
				  "\n<input type='file' name='file[]' class='multi' ".
				  "accept='gif|jpg|png|bmp|zip|pdf|txt|doc|docx|xlsx|mp3|swf' />".
				  "<div class='MultiFile-wrap' id='MultiFile5_wrap'>".
				  "<input style='position: absolute; top: -3000px;' name='' class='multi MultiFile-applied' ".
				  "accept='gif|jpg|png|bmp|zip|pdf|txt|doc|docx|xlsx|mp3|swf' type='file' />".
				  "<div class='MultiFile-list' id='MultiFile5_wrap_list'></div><div class='MultiFile-label'>".
				  "\n<input style='width: auto;' class='button' type='submit' value='Upload' />\n</div></div></form></div></div>\n";
	}
	
        /*--------------------\
        | save uploaded files |
        \--------------------*/
	function saveFiles($folder)
	{
		$num = $ix = 0;
		while(1)
		{
			$ifile = $_FILES['file']['tmp_name'][$ix];
			if(!$ifile) break;
			$fname = $_FILES['file']['name'][$ix];
			$ix++;

			$file = "$this->site/files/$folder/$fname";
			if( file_exists($file) )
			{
				$this->content .= "<div class='error'>File $fname exists!</div>";
				continue;
			}
			$file = @fopen("$this->site/files/$folder/files", "a");
			fwrite($file, "$fname|$fname|\n");
			fclose($file);
			
			$file = @fopen("$this->site/files/$folder/$fname", "w");
			$data = @file_get_contents($ifile);
			fwrite($file, $data);
			fclose($file);
			$num++;
			$this->content .= "<div class='success'>File $fname added.</div>";
		}
		if(!$ix)	$this->content .= "<div class='info'>You must specify a file to be uploaded.</div>";
		if($num)	$this->content .= "<div class='success'>$num files uploaded!</div>";
		$_SESSION['folder'] = $folder;
		$this->dirListing();
		return;
	}
		
        /*-------------\
        | update file |
        \-------------*/
	function updatefile($name)
	{
		list($site,$folder,$num) = explode(".",$name);

		$files = explode("\n",@file_get_contents("$site/files/$folder/files"));

		if($_POST['file'])
		{
			$content = "";
			$file = @fopen("$site/files/$folder/files", "w");
			$nitems = count($files);
			for($ix=0;$ix<$nitems;$ix++)
			{
				if(!trim($files[$ix])) continue;
				if($ix==$num)
				{
					$desc = preg_replace("/\n/","<br/>",$_POST['desc']);
					$content .= $_POST['fname']."|$desc|\n";
				}
				else	$content .= $files[$ix]."\n";
			}
			fwrite($file, $content);
			fclose($file);
		
			$this->content .= "<div class='success'>File $name updated!</div>";
			$this->dirListing();
			return;
		}
		list($fname,$desc) = explode("|",$files[$num]);

		$this->content .= "<form action='admin.php' method='post' enctype='multipart/form-data'>".
				  "<input type='hidden' name='files' value='update' />".
				  "<input type='hidden' name='file' value='$name' />".
				  "<input type='hidden' name='fname' value='$fname' />".
				  "<h2>Edit Description: $name</h2>".
				  "<div id='settings'>".
				  "<div class='left'>".
				  "<p>$fname</p>".
				  "</div>".
				  "<div class='right'>".
				  "<textarea class='resize' name='desc' cols='' rows=''>$desc</textarea><br />".
				  "<input style='width: auto;' class='button' type='submit' value='Update' />".
				  "</div></div></form>";
		return;
	}
	
        /*-------------\
        | delete photo |
        \-------------*/
	function deleteFile($fname)
	{
		list($site,$folder,$num) = explode(".",$fname);
		
		$files = explode("\n",@file_get_contents("$site/files/$folder/files"));

		$content = "";
		$file = @fopen("$site/files/$folder/files", "w");
		$nitems = count($files);
		for($ix=0;$ix<$nitems;$ix++)
		{
			if($ix==$num)
			{
				list($fname) = explode("|",$files[$ix]);
				if(unlink("$site/files/$folder/$fname"))
				{
					$this->content .= "<div class='success'>File $fname deleted!</div>";
				}
				else
				{
					$this->content .= "<div class='error'>Delete $fname failed!</div>";
				}
				continue;
			}
			if(!trim($files[$ix])) continue;
			$content .= $files[$ix]."\n";
		}
		fwrite($file, $content);
		fclose($file);
		
		$this->dirListing();
		return;
	}
	
        /*-----------\
        | get albums |
        \-----------*/
	function updateAlbums()
	{
		if($_COOKIE['user']!="admin")
		{
			$this->content .= "<p class='info'>You must login as <b>admin</b> to use this operation.</p>";
			return;
		}
		$this->sub_menu = "<li><a href='?albums'>Albums</a></li>".
				  "<li><a href='?albums=update'>Update</a></li>".
				  "<li><a href='?albums=photos'>Photos</a></li>".
				  "<li><a href='?albums=upload'>Upload</a></li>";

		if( $_REQUEST['albums']=="upload") return $this->uploadPhoto();
		if( $_REQUEST['albums']=="photos") return $this->displayPhotos();
		if( $_REQUEST['dlt'])		   return $this->deletePhoto($_REQUEST['dlt']);
		if( $_REQUEST['update'])	   return $this->updatePhoto($_REQUEST['update']);
		if(!$_REQUEST['albums'])	   return $this->albumsListing();
		
		if($_POST['newalbum'])
		{
			$newsite = preg_replace("'/'","_",$_POST['newalbum']);;
			if($this->createFolder("$this->site/$newsite/",$_POST['desc'],"album")) return;
			
			$file = @fopen("$this->site/albums", "a");
			fwrite($file, "$newsite|".$_POST['desc']."\n");
			fclose($file);
			
			$this->content .= "<div class='success'>Album $newsite created!</div>";
			$this->albumsListing();
			return;
		}
		if($_POST['remove'])
		{
			$this->removeFolder("albums","$this->site/".$_POST['remove']);
			
			$content = "";
			$items   = explode("\n",@file_get_contents("$this->site/albums"));
			$num     = count($items);
			for($ix=0;$ix<$num;$ix++)
			{
				list($name,$desc) = explode("|",$items[$ix]);
				if($name==$_POST['remove'] || !$name) continue;
				$content .= "$name|$desc\n";
			}
			$file = @fopen("$this->site/albums", "w");
			fwrite($file, $content);
			fclose($file);
			
			$this->albumsListing();
			return;
		}
		$albums  = explode("\n",@file_get_contents("$this->site/albums"));
		$nitems = count($albums);
		$this->content .= "<div id='settings'><form action='admin.php' method='post'>".
				  "<input type='hidden' name='albums' value='update' />".
				  "<h2>Update Albums</h2>".
				  "<div class='left'>
				  <p>Album Name</p>
				  <p>Description</p>
				  </div>
				  <div class='right'>
				  <input name='newalbum' value='' />".
				  "<input name='desc' value='' /><br />".
				  "<input style='width: auto;' class='button' type='submit' value='Add' /><br />".
				  "<select name='remove'><option value=''>SELECT</option>";
		for($ix=0;$ix<$nitems;$ix++)
		{
			list($name) = explode("|",$albums[$ix]);
			if(!$name) continue;
			$this->content .= "<option value='$name'>$name</option>";
		}
		$this->content .= "</select> <input style='width: auto;' class='button' type='submit' value='Remove' title='Remove selected Album' /></form><br />".
				  "<div class='info'>WARNING: Album removed CANNOT be recovered!</div></div></div>";
	}
	
        /*---------------\
        | albums listing |
        \---------------*/
	function albumsListing()
	{
		$this->content .= "<h2>Albums Listing</h2><ul>";
		
		$albums  = explode("\n",@file_get_contents("$this->site/albums"));
		$nitems = count($albums);

		for($ix=0;$ix<$nitems;$ix++)
		{
			list($name,$desc) = explode("|",$albums[$ix]);
			$desc = stripslashes($desc);
			if(!$name) continue;
			$this->content .= "<li><a href='?album=$name&albums=photos'><b>$name</b></a> - $desc</li>";
		}
		$this->content .= "</ul>";
	}
	
        /*-------------\
        | upload photo |
        \-------------*/
	function uploadPhoto()
	{
		$albums = trim(@file_get_contents("$this->site/albums"));
		if($albums=="")
		{
			$this->content .= "<div class='info'>You must create an album before you can use this function!</div>";
			return;
		}
		
		$resize = $_REQUEST['resize'];
		$thumb  = $_REQUEST['thumb'];
		if(!$thumb) $thumb = 100;
		if($_POST['albums'])
		{
			if($_POST['album']) $this->savePhoto($_POST['album'],$resize,$thumb);
			else $this->content .= "<div class='info'>You must select an album for this function!</div>";
		}

		$albums  = explode("\n",$albums);
		$nitems  = count($albums);
		
		$name = $selected = $_SESSION['album'];
		if(!$name) $selected = "SELECT";
		$this->content .= "\n<form class='P10' action='admin.php' method='post' enctype='multipart/form-data'>".
				  "\n<input type='hidden' name='albums' value='upload' />".
				  "\n<h2>Update Albums</h2>".
				  "\n<p><b>Album</b> <select name='album'><option value='$name'>$selected</option>";
		for($ix=0;$ix<$nitems;$ix++)
		{
			list($name) = explode("|",$albums[$ix]);
			if(!$name) continue;
			$this->content .= "<option value='$name'>$name</option>";
		}
		$this->content .= "</select></p><p>".
				  "\n<h3>Upload photos</h3>".
				  "\n<div id='settings'>".
				  "\n<div class='left'>".
				  "\n<p>Width (optional)</p>".
				  "\n<p>Image Files</p>".
				  "\n</div>".
				  "\n<div class='right'>".
				  "Full size: <input name='resize' style='width:50px' value='$resize' /> &nbsp; &nbsp;".
				  "Thumbnail: <input name='thumb' style='width:50px' value='$thumb' />".
				  "\n<input type='file' name='file[]' class='multi' accept='gif|jpg|png' />".
				  "<div class='MultiFile-wrap' id='MultiFile5_wrap'>".
				  "<input style='position: absolute; top: -3000px;' name='' class='multi MultiFile-applied' accept='gif|jpg|png|bmp' type='file' />".
				  "<div class='MultiFile-list' id='MultiFile5_wrap_list'></div><div class='MultiFile-label'>".
				  "\n<input style='width: auto;' class='button' type='submit' value='Upload' />\n</div></div></form></div></div>\n";
	}

	
        /*--------------------\
        | save uploaded photo |
        \--------------------*/
	function savePhoto($folder,$resize,$thumb)
	{
		$num = $ix = 0;
		while(1)
		{
			$ifile = $_FILES['file']['tmp_name'][$ix];
			if(!$ifile) break;
			$fname = $_FILES['file']['name'][$ix];
			$ix++;

			if( file_exists("$this->site/$folder/$fname") )
			{
				$this->content .= "<div class='error'>File $fname exists!</div>";
				continue;
			}
			if(! $this->resizeImage($ifile,$resize,$thumb,$folder,$fname,""))
			{
				continue;
			}
			$file = @fopen("$this->site/$folder/photos", "a");
			fwrite($file, "$fname|$fname||$this->full|$this->thumb|\n");
			fclose($file);
			$num++;
			$this->content .= "<div class='success'>File $fname added.</div>";
		}
		if(!$ix)	$this->content .= "<div class='error'>You must specify a file to be uploaded.</div>";
		elseif(!$num)	$this->content .= "<div class='error'>Error encountered in saving files!</div>";
		else
		{
			$this->content .= "<div class='success'>$num files uploaded!</div>";
			$this->miscActivity("uploaded","$num photos into",$folder,"");
		}
		return;
	}
	
        /*-------------\
        | delete photo |
        \-------------*/
	function deletePhoto($name)
	{
		list($site,$album,$num) = explode(".",$name);
		
		$photos = explode("\n",@file_get_contents("$site/$album/photos"));

		$content = "";
		$file = @fopen("$site/$album/photos", "w");
		$nitems = count($photos);
		for($ix=0;$ix<$nitems;$ix++)
		{
			if($ix==$num)
			{
				list($fname) = explode("|",$photos[$ix]);
				if(unlink("$site/$album/$fname") && unlink("$site/$album/_$fname"))
				{
					$this->content .= "<div class='success'>Photo $fname deleted!</div>";
				}
				else
				{
					$this->content .= "<div class='error'>Delete photo $fname failed!</div>";
				}
				continue;
			}
			if(!trim($photos[$ix])) continue;
			$content .= $photos[$ix]."\n";
		}
		fwrite($file, $content);
		fclose($file);
		

		$_SESSION['album'] = $album;
		$_REQUEST['albums'] = "photos";
		$this->updateAlbums();
		return;
	}
	
        /*-------------\
        | update photo |
        \-------------*/
	function updatePhoto($name)
	{
		list($site,$album,$num) = explode(".",$name);
	
		$photos = explode("\n",@file_get_contents("$site/$album/photos"));
		list($ifile,$desc,$hide,$full,$thumb) = explode("|",$photos[$num]);

		if($_POST['update'])
		{
			$content = "";
			$file = @fopen("$site/$album/photos", "w");
			$nitems = count($photos);
			for($ix=0;$ix<$nitems;$ix++)
			{
				if(!trim($photos[$ix])) continue;
				if($ix==$num)
				{
					$desc  = stripslashes($_POST['desc']);
					$desc  = preg_replace("/\|/","*",$desc);
					$desc  = preg_replace("/\n/","<br/>",$desc);
					$hide  = $_POST['hide'];
					if($_POST['full'])
					{
						$full = $_POST['full'];
						$this->resizeImage("$site/$album/$ifile",$full,"",$album,$ifile,"$site/$album/$ifile");
					}
					if($_POST['thumb'])
					{
						$thumb = $_POST['thumb'];
						$this->resizeImage("$site/$album/$ifile",$thumb,"",$album,$ifile,"$site/$album/_$ifile");
					}
					$content .= $_POST['img']."|$desc|$hide|$full|$thumb|\n";
				}
				else	$content .= $photos[$ix]."\n";
			}
			fwrite($file, $content);
			fclose($file);
		
			$this->content .= "<div class='success'>Photo $name updated!</div>";
			$_REQUEST['albums'] = "photos";
			$this->updateAlbums();
			return;
		}
		if($hide=="hide") $hide = "checked";
		else $show = "checked";
		$this->content .= "<form action='admin.php' method='post' enctype='multipart/form-data'>".
				  "<input type='hidden' name='update' value='$name' />".
				  "<input type='hidden' name='img' value='$ifile' />".
				  "<h2>Edit Description: $name</h2>".
				  "<div id='settings'>".
				  "<div class='left'>".
				  "<p><img src='$site/$album/_$ifile' /></p>".
				  "</div>".
				  "<div class='right'>".
				  "<textarea class='resize' name='desc' cols='' rows=''>$desc</textarea><br />".
				  "Resize -  &nbsp; &nbsp; ".
				  "Original ($full): <input style='width: 40px;' name='full' value='' /> &nbsp; &nbsp; ".
				  "Thumbnail ($thumb): <input style='width: 40px;' name='thumb' value='' /><br />".
				  "<input style='width: 10px;' type='radio' name='hide' value='hide' $hide /> _hide &nbsp; &nbsp; ".
				  "<input style='width: 10px;' type='radio' name='hide' value='show' $show /> _show <br />".
				  "<input style='width: auto;' class='button' type='submit' value='Update' />".
				  "</div></div></form>";
		return;
	}
	
        /*---------------\
        | display photos |
        \---------------*/
	function displayPhotos()
	{
		if(!$_SESSION['album'])
		{
			$this->content .= "<div class='info'>You must select an album for this function!</div>";
			return;
		}
		$this->album = $_SESSION['album'];
		$this->content .= "<h2>Albums: $this->album</h2><table cellspacing='0'>\n<form action='admin.php' action='post'>";
		$photos = explode("\n",@file_get_contents("$this->site/$this->album/photos"));
		$nitems = count($photos);
		for($ix=0;$ix<$nitems;$ix++)
		{
			list($name,$desc,$hide,$full,$thumb) = explode("|",$photos[$ix]);
			if(!$name) continue;
			if($hide=="hide") $bkg = "style='border: 3px red solid;' title='This image is hidden'";
			else $bkg = "style='border: 3px silver solid;' title='$name'";
			$this->content .= "\n<tr><td><a href='?dlt=$this->site.$this->album.$ix' title='delete this photo'>".
					  "<img src='images/delete.png' title='Delete this image: $name' alt='Delete' /></a>".
					  "<img $bkg src='$this->site/$this->album/_$name' alt='Photo'/></td><td>".
					  "<a href='?update=$this->site.$this->album.$ix'>".
					  "<img src='images/pencil.png' title='Edit description: $name' alt='Edit' /></a><br />$desc</td>".
					  "<td>$full - $thumb</td></tr>";
		}
		$this->content .= "</table>";
		return;
	}
	
        /*-------------\
        | resize image |
        \-------------*/
        function resizeImage($inpFile,$fsize,$tsize,$folder,$fname,$outFile)
        {
		$full  = "$this->site/$folder/$fname";
		$thumb = "$this->site/$folder/_$fname";
		list($width,$height,$type,$attr) = GetImageSize($inpFile);

		if($type==IMAGETYPE_JPEG)	$img = @imagecreatefromjpeg($inpFile);
		elseif($type==IMAGETYPE_GIF)	$img = @imagecreatefromgif ($inpFile);
		elseif($type==IMAGETYPE_PNG)	$img = @imagecreatefrompng ($inpFile);
		else
		{
			$this->content .= "<div class='error'>($type) Image file type not supported!</div>";
			return;
		}

		if(!$img)
		{
			$this->content .= "<div class='error'>Unable to create image!</div>";
			return;
		}
		$opt1 = $fsize;
		if(!$opt1 || $opt1>$width)
		{
			$opt1 = $width;
			$opt2 = $height;
		}

		$opt2 = $opt1/$width * $height;
		$new1 = imagecreatetruecolor($opt1,$opt2);
		imagecopyresized ( $new1, $img, 0, 0, 0, 0, $opt1,$opt2,$width,$height);
		$this->full = $opt1;

		if(!$outFile)
		{
			if($width<100) $opt1 = $width;
			else $opt1 = 100;
			$this->thumb = $opt1;
		
			$opt2 = $opt1/$width * $height;
			$new2 = imagecreatetruecolor($opt1,$opt2);
			imagecopyresized ( $new2, $img, 0, 0, 0, 0, $opt1,$opt2,$width,$height);
		}
		$stat = 0;
		if($type==IMAGETYPE_JPEG)
		{
			if($outFile) $stat = @ImageJpeg($new1,$outFile);
			else
			{
				$stat = @ImageJpeg($new1,$full);
				$stat = @ImageJpeg($new2,$thumb);
			}
			$this->filetype = "jpg";
		}
	        elseif($type==IMAGETYPE_GIF)
		{
			if($outFile) $stat = @ImageJpeg($new1,$outFile);
			else
			{
				$stat = @ImageGif ($new1,$full);
				$stat = @ImageGif ($new2,$thumb);
			}
			$this->filetype = "gif";
		}
	        else
		{
			if($outFile) $stat = @ImageJpeg($new1,$outFile);
			else
			{
				$stat = @ImagePng ($new1,$full);
				$stat = @ImagePng ($new2,$thumb);
			}
			$this->filetype = "png";
		}
		if(!$stat)
		{
			$this->content .= "<div class='error'>Error: resizeImage($inpFile,$fsize,$tsize,$folder,$fname,$outFile)</div>";
			return;
		}
		@imagedestroy($new1);
		@imagedestroy($new2);
		@imagedestroy($img);

		return 1;
	}
		
        /*---------------\
        | photos listing |
        \---------------*/
	function photosListing()
	{
		$this->content .= "<h3>Photos Listing</h3><ul>";
		
		$this->content .= "<div class='info'>Function under construction...</div>";
	}
	
        /*------------------\
        | create new folder |
        \------------------*/
	function createFolder($newfolder,$description,$type)
	{
		if (is_dir($newfolder))
		{
			$this->content .= "<div class='error'>$newfolder already exists!</div>";
			return 1;
		}
		if(!@mkdir($newfolder, 0755))
		{
			$this->content .= "<div class='error'>*** FATAL *** unable to create folder $newfolder!</div>";
			return 1;
		}
		
		if($type == "file")
		{
			$file = @fopen("$newfolder/files", "w");
			fclose($file);
			return 0;
		}
		if($type == "album")
		{
			$file = @fopen("$newfolder/photos", "w");
			fclose($file);
			return 0;
		}
		$content = "<?php\n".
			   "class localFunctions {\n".
			   "function localFunctions(){	}\n}\n?>\n";
		$file = @fopen("$newfolder/localFunctions.php", "w");
		if(!$file)
		{
			$this->content .= "<div class='error'>*** FATAL *** unable to create files in $newfolder!</div>".
					  "<p>Please make sure read/write permissions are enabled!</p>";
			return 1;
		}
		fwrite($file, "$content");
		fclose($file);
		
		$content = @file_get_contents("main/index.php");
		$file = @fopen("$newfolder/index.php", "w");
		fwrite($file, $content);
		fclose($file);

		$content = @file_get_contents("welcome");
		$file = @fopen("$newfolder/page-1", "w");
		fwrite($file, $content);
		fclose($file);

		$content = @file_get_contents("themes");
		$file = @fopen("$newfolder/themes", "w");
		fwrite($file, $content);
		fclose($file);

		$file = @fopen("sites", "a");
		fwrite($file, "$newfolder|$description\n");
		fclose($file);
		
		$this->content .= "<div class='success'><a href='./$newfolder'>$newfolder</a> created!</div>";
		return 0;
	}

        /*--------------\
        | remove folder |
        \--------------*/
	function removeFolder($list,$folder)
	{
		$deleted = 0;
		if (!is_dir($folder))
		{
			$this->content .= "<div class='error'>$folder not found!</div>";
		}
		else
		{
			$this->unlinkRecursive($folder);
			$deleted++;
		}		
		if($deleted) $this->content .= "<div class='success'>Folder $folder deleted!</div>";
	}

	/*------------------\
        |  unlink Recursive |
        \------------------*/
	function unlinkRecursive($dir)
	{
		if(!$dh = @opendir($dir))
		{
			return;
		}
		while (false !== ($obj = readdir($dh)))
		{
			if($obj == '.' || $obj == '..')
			{
				continue;
			}

			if (!@unlink($dir . '/' . $obj))
			{
				$this->unlinkRecursive($dir.'/'.$obj);
			}
		}

		closedir($dh);
   
		@rmdir($dir);

		return;
	}
			
        /*----------------\
        | get menu groups |
        \----------------*/
	function getMenuGroups()
	{
		$menus = explode("^^^",@file_get_contents("$this->site$this->language/menus"));
		$gnum  = count($menus)-1;
		for($ix=0;$ix<$gnum;$ix++)
		{
			$this_groups = explode("\n",$menus[$ix]);

			$parent = "";
			$inum = count($this_groups); // get number of items in group 
			for($jx=$snum=$npages=0;$jx<$inum;$jx++)
			{
				$this->groups[$ix][$snum] = explode("|",$this_groups[$jx]);
				$sectnum = trim($this->groups[$ix][$snum][0]);
				if(!$sectnum) continue;
				$npages++;
				list($name1,$sname) = explode(".",$this->groups[$ix][$snum][1]);
				if($sname)
				{
					if(!$parent)
					{
						$subnum = 0;
						$parent = $name1;
					}
					$this->subs[$pnum][$subnum] = $this->groups[$ix][$snum];
					$this->subs[$pnum][$subnum][1] = $sname;
					$subnum++;
					continue;
				}
				$parent = "";
				$pnum   = $sectnum;
				$snum++;
			}
			$this->content .= "<a href='?menus&g=$ix'>Group $ix</a> : $npages pages<br />";
		}
		return $gnum;
	}
	
        /*-------------\
        | display menu |
        \-------------*/
	function displayMenu($num)
	{
		$gnum = count($this->groups[$num]);
		//if($gnum<2) return;
		$this->content .= "<h3>Group $num</h3><table style='width: auto;' cellspacing='0'><tr>".
				  "<th>ID</th><th>Name</th><th>Title</th><th>Attributes</th><th>Theme</th>".
				  "<th style='border-right: 1px solid #666;'>Type</th></tr>\n";
		for($ix=0;$ix<$gnum;$ix++)
		{
			$idnum = $id = trim($this->groups[$num][$ix][0]);
			if(!$idnum) continue;
			if($id<0)
			{
				$id *= -1;
				$hide = "style='color: #c00'";
			}
			else	$hide = "";
			$this->content .= "<tr $hide><td nowrap=nowrap><a href='?delete=$idnum&g=$num'>".
					  "<img src='images/delete.png' title='Delete $idnum' /></a> $id</td><td>".
					  " <a href='?add=$idnum&g=$num' title='Add sub page'><img src='images/page_add.png' /></a> ".
					  stripslashes($this->groups[$num][$ix][1])."</td><td>".
					  stripslashes($this->groups[$num][$ix][2])."</td><td>".
					  stripslashes($this->groups[$num][$ix][3])."</td><td>".
					  $this->groups[$num][$ix][4]."</td><td>".
					  $this->groups[$num][$ix][5]." ".$this->groups[$num][$ix][6].
					  $this->popupWindow("admin.php?menu=$idnum&g=$num",610,550,
					    "<img src='images/pencil.png' title='Edit $idnum' height='20px' alt='Edit' />").
					     "</td></tr>\n";
			if($this->subs[$id])
			{
				$snum = count($this->subs[$id]);
				for($jx=0;$jx<$snum;$jx++)
				{
					$idnum = trim($this->subs[$id][$jx][0]);
					if(!$idnum) continue;
					if($idnum<0) $hide = "style='color: #c00;'";
					else $hide = "";
					$snum = $idnum;
					if($snum<0) $snum *= -1;
					$this->content .= "<tr $hide bgcolor='#dcdcdc'><td nowrap=nowrap><a href='?delete=$idnum&g=$num'>".
						"<img src='images/delete.png' title='Delete $idnum' /></a> $snum <td>".
						" <a href='?add=$idnum&g=$num' title='Add sub page'><img src='images/page_add.png' /></a> - ".
						stripslashes($this->subs[$id][$jx][1])."</td><td>".
						stripslashes($this->subs[$id][$jx][2])."</td><td>".
						stripslashes($this->subs[$id][$jx][3])."</td><td>".
						$this->subs[$id][$jx][4]."</td><td>".
						$this->subs[$id][$jx][5]." ".$this->groups[$num][$ix][6].
						$this->popupWindow("admin.php?menu=$idnum&g=$num",610,550,
						   "<img src='images/pencil.png' title='Edit $idnum' height='20px' alt='Edit' />").
						   "</td></tr>\n";
				}
			}
		}
		$this->content .= "</table><p><a href='?menus=add&group=$num' title='Add new page into this group'>".
				  "<img src='images/page_add.png' /> Add New Page </a></p>";
	}
	
        /*-----------------\
        | update menu item |
        \-----------------*/
	function updateMenuItem($pnum)
	{
		if($_POST['menu'])
		{

			$this->saveMenuItem($_POST['menu']);
			echo "<html><head></head><body onload='window.opener.location.reload();window.close()'></body></html>";
			exit;
		}
		echo "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>".
			"<html xmlns='http://www.w3.org/1999/xhtml' lang='en' xml:lang='en'>".
			"<head>\n<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />".
			"<title>w-CMS - Edit Menu - Page $pnum</title>\n".
			"<link rel='stylesheet' type='text/css' href='css/menu-edit.css' />\n</head>\n<body>\n".
			"<h2>Menu: <span class='page'>Page $pnum</span></h2>\n";

		if($_COOKIE['user']!="admin")
		{
			echo "<p class='info'>You must login as <b>admin</b> to use this operation!</p>".
				"<button class='button' onclick='window.close()'>Cancel</button>";
			exit;
		}
		$menus = explode("\n",@file_get_contents("$this->site$this->language/menus"));
		$inum = count($menus);

		for($ix=0;$ix<$inum;$ix++)
		{
			list($id,$pname,$ptitle,$attrs,$theme,$ptype,$fname,$meta) = explode("|",$menus[$ix]);
			if($id!=$pnum) continue;
			if($id<0)
			{
				$hide = "checked";
			}
			else	$show = "checked";
			switch($ptype)
			{
				case 'static' :		$static = "checked"; break;
				case 'redirect' :	$redirect = "checked"; break;
				case 'templates' :	$templates = "checked"; break;
				case 'forum' :		$forum = "checked"; break;
				case 'guestbook' :	$guestbook = "checked"; break;
				case 'blog' :		$blog = "checked"; break;
				case 'news' :		$news = "checked"; break;
				case 'mail' :		$mail = "checked"; break;
				case 'latest' :		$latest = "checked"; break;
				case 'download' :	$download = "checked"; break;
				case 'myfunction' :	$myfunction = "checked"; break;
				case 'gallery' :
				case 'gallery_0' :	$gallery_0 = "checked"; break;
				case 'gallery_1' :	$gallery_1 = "checked"; break;
			}
			list($parent,$pname) = explode(".",$pname);
			if(!$pname)
			{
				$pname  = $parent;
				$parent = "";
			}
			if($theme)
			{
				$selected = $theme;
			}
			else	$selected = "SELECT";
			$themes = explode("\n",@file_get_contents("$this->site$this->language/themes"));
			$tlist  = "<select name='theme'> <option value='$theme'>$selected</option>\n<option value=''>NONE</option>\n";
			$num = count($themes);
			for($ix=0;$ix<$num;$ix++)
			{
				$theme = trim($themes[$ix]);
				if(!$theme) continue;
				$tlist .= "<option value='$theme'>$theme</option> \n";
			}
			$tlist .= "</select> NONE=site-wide theme\n";
			if(@file_get_contents("$this->site/designer"))
			{
				$tpl = "<input class='radio' type='radio' name='ptype' value='templates' $templates /> templates\n";
			}
			$ptitle = preg_replace("/\'/","&#39;",stripslashes($ptitle));
			$attrs  = preg_replace("/\'/","&#39;",stripslashes($attrs));
			$pname  = preg_replace("/\'/","&#39;",stripslashes($pname));
			$meta   = preg_replace("/\1/","\n",stripslashes($meta));
			echo "<form action='admin.php' method='post'>".
				"<input type='hidden' name='menu' value='$pnum' />".
				"<input type='hidden' name='site' value='$this->site' />".
				"<input type='hidden' name='language' value='$this->language' />".
				"<div class='left'>Name:</div><div class='right'><input type='hidden' name='parent' value='$parent' />$parent ".
				"<input name='pname' value='$pname'  /><br />\n".
				"<input class='radio' type='radio' name='hide' value='hide' $hide />_Hide ".
				"<input class='radio' type='radio' name='hide' value='show' $show />_Show </div>\n".
				"<div class='left'>Title:</div><div class='right'><input  name='ptitle' value='$ptitle' /></div>\n".
				"<div class='left'>Attributes:</div><div class='right'><input name='attrs' value='$attrs' /></div>\n".
				"<div class='left'>Theme:</div><div class='right'>$tlist</div>\n".
				"<div class='left'></div><div class='right'><input name='dtheme' value='$dtheme' /></div>\n".
				"<div class='left'>Type:</div>".
				"<div class='right'><input class='radio' type='radio' name='ptype' value='static' $static />Static\n".
				"<input class='radio' type='radio' name='ptype' value='forum' $forum />Forum\n".
				"<input class='radio' type='radio' name='ptype' value='blog' $blog />Blog\n".
				"<input class='radio' type='radio' name='ptype' value='news' $news />News\n".
				"<input class='radio' type='radio' name='ptype' value='guestbook' $guestbook /> Guestbook\n".
				"<input class='radio' type='radio' name='ptype' value='mail' $mail />Mail <br />\n".
				"<input class='radio' type='radio' name='ptype' value='redirect' $redirect /> Redirect\n".
				"<input class='radio' type='radio' name='ptype' value='latest' $latest /> Activity\n".
				"<input class='radio' type='radio' name='ptype' value='download' $download /> Download<br />\n".
				"<input class='radio' type='radio' name='ptype' value='myfunction' $myfunction /> MyFunction\n".
				"<input class='radio' type='radio' name='ptype' value='gallery_0' $gallery_0 /> Gallery 0\n".
				"<input class='radio' type='radio' name='ptype' value='gallery_1' $gallery_1 /> Gallery 1\n".
				"$tpl</div>\n".
				"<div class='left'>File/Site:</div><div class='right'><input name='fname' value='$fname' /></div>\n".
				"<div class='left'>Meta Tags:</div><div class='right'>".
				"<textarea name='meta_tags' rows='' cols='' >$meta</textarea><br />\n".
				"<input class='button' type='submit' value='Save' /> ".
				"<button class='button' onclick='window.close()'>Cancel</button></div>\n</form></body></html>";
			exit;
		}
		echo "<p class='error'>Record not found!</p>".
			"<button class='button' onclick='window.close()'>Close</button>";
		exit;
	}
	
        /*---------------\
        | save menu item |
        \---------------*/
	function saveMenuItem($mid)
	{
		$menu   = ""; 
		$menus  = explode("\n",@file_get_contents("$this->site$this->language/menus"));
		$nitems = count($menus);
		for($ix=0;$ix<$nitems;$ix++)
		{
			list($id,$oldname) = explode("|",$menus[$ix]);
			if($id!=$mid)
			{
				list($parent,$pname) = explode(".",$oldname);

				if($newname&&$pname) $menus[$ix] = stripslashes(preg_replace("/$parent\./","$newname\.",$menus[$ix]));
				else $newname = "";
				
				$menu .= $menus[$ix]."\n";
				continue;
			}
			if($_REQUEST['delete'])
			{
				continue;
			}
			$meta_tags = stripslashes(preg_replace("/\r\n|\n/","\1",$_POST['meta_tags']));
			$attrs     = stripslashes($_POST['attrs']);
			$ptitle    = stripslashes($_POST['ptitle']);
			
			if($mid<0) $mid *= -1;
			if($_POST['hide']=="hide") $mid *= -1;

			$pname  = $_POST['pname'];
			if($_POST['parent']) $pname = $_POST['parent'].".$pname";
			else
			{
				$newname = $pname;
			}
			$theme = $_POST['dtheme'];
			if(!$theme) $theme = $_POST['theme'];
			$menu .= "$mid|$pname|$ptitle|$attrs|$theme|".
				 $_POST['ptype']."|".$_POST['fname']."|$meta_tags|\n";
		}
		$file = @fopen("$this->site$this->language/menus", "w");
		if(!$file)
		{
			echo "<p class='error'>*** FATAL *** unable to open $this->site$this->language/menus</p>Please make sure read/write permissions are enabled.";
			exit;
		}
		$menu = trim($menu);
		fwrite($file, $menu);
		fclose($file);
	}
	
        /*-------------------\
        | update menu groups |
        \-------------------*/
	function updateMenus()
	{
		if($_COOKIE['user']!="admin")
		{
			$this->content .= "<p class='info'>You must login as <b>admin</b> to use this operation.</p>";
			return;
		}
		$this->sub_menu = "<li><a href='?menus'>Display</a></li>".
				  "<li><a href='?menus=update'>Update</a></li>".
				  "<li><a href='?menus=generate'>Generate HTML pages</a></li>".
				  "<li><a href='?menus=remove'>Remove HTML pages</a></li>";
		if($_REQUEST['menus']=="generate")
		{
			$this->processHTML("add");
			return;
		}
		if($_REQUEST['menus']=="remove")
		{
			$this->processHTML("remove");
			return;
		}
		$upd = 0;
		if(isset($_POST['content']))
		{
			$contents = explode("\n",$_POST['content']);
			$nitems   = count($contents);
			$content  = "";
			for($ix=0;$ix<$nitems;$ix++)
			{
				$item = trim($contents[$ix]);
				if(!$item) continue;
				$content .= "$item\n";
			}
			$file = @fopen("$this->site$this->language/menus", "w");
			if(!$file)
			{
				$this->content .= "<div class='error'>*** FATAL *** unable to open $this->site$this->language/menus!</div>".
					"<p>Please make sure read/write permissions are enabled!</p>";
				return;
			}
			else
			{
				fwrite($file, $content);
				fclose($file);
			}
			$this->content .= "<div class='success'>Menus List updated!</div>";
			$upd++;
		}
		if(!$_REQUEST['menus']||$upd)
		{
			if($_REQUEST['g']=="add")
			{
				$file = @fopen("$this->site$this->language/menus", "a");
				fwrite($file, "^^^\n");
				fclose($file);
			}
			$this->content .= "<h2>Site: $this->site</h2>";
			$gnum = $this->getMenuGroups();
			$this->content .= "<br /><a href='?menus&g=add'>Add New Group</a><br /><hr /><br />";
			if(isset($_REQUEST['g']) && $_REQUEST['g']!="add") $this->displayMenu($_REQUEST['g']);
			return;
		}
		$content = stripslashes(@file_get_contents("$this->site$this->language/menus"));

		$this->content .= "<h2>Update Menus: $this->site</h2>
		<p><b>Please use this function to rearrange menu items or<br />you have numerous changes.</b></p>
<form action='admin.php' method='post'>
<input type='hidden' name='site' value='$this->site' />
<input type='hidden' name='language' value='$this->language' />
<input type='hidden' name='menus' value='update' />
<textarea class='resize' name='content' rows='' cols=''>$content</textarea>
<br />
<input class='button' type='submit' value='Save' />
</form>
<h3>Format:</h3>
<pre>
^^^
ID<i style='color: gray'>(group 0 - Menu 0)</i>|Name|Title|Attributes|Theme|Type|<u style='color: blue'>URL/File</u>|
^^^
ID<i style='color: gray'>(group 1 - Menu 1)</i>|Name|Title|Attributes|Theme|Type|<u style='color: blue'>URL/File</u>|
^^^
... add more groups if needed

Support <b>sub pages</b> (one level only). Example:
1|Page 1|Page 1 title||||
2|Page 1.Sub Page 1|Sub page 1 title||||
3|Page 1.Sub Page 2|Sub page 2 title||||
4|Page 2|Page 2 title||||

<u style='color: green'>Type</u>: forum, blog, gallery, redirect

</pre>
";

	       return 1;
	}
	
        /*---------\
        | add page |
        \---------*/
	function addPage($group)
	{
		$nxpage = $this->nextPageNum();
		$menus = explode("^^^",@file_get_contents("$this->site$this->language/menus"));
		$menus[$group] .= "$nxpage|New Page|Page Title||||||";
		$gnum = count($menus)-1;
		$data = ""; 
		for($ix=0;$ix<$gnum;$ix++)
		{
			$menu = trim($menus[$ix]);
			$data .= "$menu\n^^^\n";
		}
		$file = @fopen("$this->site$this->language/menus", "w");
		if(!$file)
		{
			echo "<p class='error'>*** FATAL *** unable to open $this->site$this->language/menus</p>Please make sure read/write permissions are enabled.";
			exit;
		}
		
		$this->miscActivity("added","page",$nxpage,"?site=$this->site&p=$nxpage");
		
		fwrite($file, $data);
		fclose($file);
	}
	
        /*-------------\
        | add sub page |
        \-------------*/
	function addSubPage($pnum)
	{
		$nxpage = $this->nextPageNum();
		$groups = explode("^^^",@file_get_contents("$this->site$this->language/menus"));
		$gnum   = count($groups)-1;
		$data   = "";
		for($ix=0;$ix<$gnum;$ix++)
		{
			$menus = explode("\n",$groups[$ix]);
			$nitem = count($menus)-1;
			for($jx=0;$jx<$nitem;$jx++)
			{
				$data .= $menus[$jx]."\n";
				list($id,$pname) = explode("|",$menus[$jx]);
				if($id==$pnum)
				{
					list($pname) = explode(".",$pname);
					$data .= "$nxpage|$pname.New Page|Page Title||||||\n";
					$this->group = $ix;
				}
			}
			$data .= "^^^\n";
		}
		$file = @fopen("$this->site$this->language/menus", "w");
		if(!$file)
		{
			echo "<p class='error'>*** FATAL *** unable to open $this->site$this->language/menus</p>".
					"<p>Please make sure read/write permissions are enabled.</p>";
			exit;
		}
		fwrite($file, $data);
		fclose($file);
	}
	
        /*-----------------\
        | next page number |
        \-----------------*/
	function nextPageNum()
	{
		$menus = explode("\n",@file_get_contents("$this->site$this->language/menus"));
		$gnum  = count($menus);
		for($ix=0;$ix<$gnum;$ix++)
		{
			list($id) = explode("|",$menus[$ix]);
			$id = trim($id);
			if(!$id || $id=="^^^") continue;
			if($id<0) $id *= -1;
			$ids[$id] = $id;
		}
		sort($ids);
		$nitems = count($ids);
		for($ix=0;$ix<$nitems;$ix++)
		{
			$num = $ix+1;
			if($num != $ids[$ix]) return $num;
		}
		return $nitems+1;
	}
	
        /*----------------------\
        | update section titles |
        \----------------------*/
	function updateSections()
	{
		if($_COOKIE['user']!="admin")
		{
			$this->content .= "<p class='info'>You must login as <b>admin</b> to use this operation.</p>";
			return;
		}
		if(isset($_POST['sections']))
		{
			$sections = rtrim($_POST['sections']);
			$file = @fopen("$this->site$this->language/sections", "w");
			if(!$file)
			{
				$this->content .= "<div class='error'>*** FATAL *** unable to open 'sections' file!</div>".
					"<p>Please make sure read/write permissions are enabled!</p>";
				return;
			}
			fwrite($file, $sections);
			fclose($file);
			$this->content .= "<div class='info'>Section Titles Updated";
			return;
		}
		$sections = @file_get_contents("$this->site$this->language/sections");
		$this->content .= "<h2>Section Titles</h2>\n".
				  "<form action='admin.php' method='post'>\n".
				  "<textarea class='resize' name='sections' rows='15' cols='20'>$sections</textarea><br />\n".
				  "<input class='button' type='submit' value='Save' /></form>\n";
		return;
	}
	
        /*------------------\
        | update theme list |
        \------------------*/
	function updateThemes()
	{
		if($_COOKIE['user']!="admin")
		{
			$this->content .= "<p class='info'>You must login as <b>admin</b> to use this operation.</p>";
			return;
		}
		if(isset($_POST['themes']))
		{
			$themes = rtrim($_POST['themes']);
			$file = @fopen("$this->site$this->language/themes", "w");
			if(!$file)
			{
				$this->content .= "<div class='error'>*** FATAL *** unable to open 'themes' file!</div>".
					"<p>Please make sure read/write permissions are enabled!</p>";
				return;
			}
			fwrite($file, $themes);
			fclose($file);
			$this->content .= "<div class='info'>Themes List updated!</div><h3>Themes Selection:</h3><pre>$themes</pre>";
			return;
		}
		$themes = @file_get_contents("$this->site$this->language/themes");
		$this->content .= "<h2>Theme Selection List</h2>\n".
				  "<p><b/>Add/Remove Themes<b/></p>\n".
				  "<form action='admin.php' method='post'>\n".
				  "<input type='hidden' name='settings' value='themes' />\n".
				  "<textarea class='resize' name='themes' rows='15' cols='20'>$themes</textarea><br />\n".
				  "<input class='button' type='submit' value='Save' /></form>\n";
		return;
	}
	
        /*---------------------\
        | update download list |
        \---------------------*/
	function updateDownloads()
	{
		if($_COOKIE['user']!="admin")
		{
			$this->content .= "<p class='info'>You must login as <b>admin</b> to use this operation.</p>";
			return;
		}
		$this->DOWNLOADS = new SQLiteDatabase("./$this->site/downloads.dbf");

		$this->getDownloads();
	}
	
	/*--------------\
        | get downloads |
        \--------------*/
	function getDownloads()
	{
		if($_GET['dn']=="add")
		{
			$dtime = time();
			$this->DOWNLOADS->query("INSERT INTO downloads VALUES(NULL,'Name','Description','','0','$dtime')");
		}
		if($_GET['dn']=="dlt")
		{
			$this->DOWNLOADS->query("DELETE FROM downloads WHERE did='".$_GET['did']."'");
		}

		$this->content .= "<h3>Downloads</h3><table style='width: auto;' cellspacing='0'>\n";
		$q = @$this->DOWNLOADS->query("SELECT * FROM downloads ORDER BY Name");
		if ($q === false)
		{
			$this->createDnDbase();
			$q = @$this->DOWNLOADS->query("SELECT * FROM downloads ORDER BY Name");
		}

		while( $q->valid() )
		{
			list($did,$name,$description,$location,$ndls,$datetime) = $q->current();
			$datetime = date ("m/d/y - g:i:s A",$datetime);

			$this->content .= "<tr>".
				"<td><a href='?settings=downloads&dn=dlt&did=$did' title='Delete this item'>".
				"<img src='images/delete.png' />".
				"$name</a></td><td>$description</td>".
				"<td>$location</td><td>$ndls</td><td>$datetime</td><td>".  
				$this->popupWindow("?settings=downloads&dn=edit&did=$did",610,300,
				   "<img src='images/pencil.png' height='20px' alt='Edit' />").
				"</td></tr>";
			
			$q->next();
		}
		$this->content .= "</table><p><a href='?settings=downloads&dn=add' title='Add new download'>".
				  "<img src='images/page_add.png' /> Add New Download </a></p>";
	}

        /*-------------------------------\
        | create download database table |
        \-------------------------------*/
	function createDnDbase()
	{
		$this->DOWNLOADS->query("CREATE TABLE downloads".
			"(did INTEGER PRIMARY KEY, Name CHAR(80), Description TEXT, Location CHAR(80), ndls INTEGER, mdate INTEGER)");
	}
	
        /*----------------\
        | update download |
        \----------------*/
	function updateDownload()
	{
		if($_POST['dn'])
		{
			$this->saveDnItem();
			echo "<html><head></head><body onload='window.opener.location.reload();window.close()'></body></html>";
			exit;
		}
		echo "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>\n".
			"<html xmlns='http://www.w3.org/1999/xhtml' lang='en' xml:lang='en'>\n".
			"<head>\n<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />\n".
			"<title>w-CMS - Edit Download</title>\n".
			"<link rel='stylesheet' type='text/css' href='css/menu-edit.css' />\n</head>\n<body>\n".
			"<h2>Download</h2>\n";

		if($_COOKIE['user']!="admin")
		{
			echo "<p class='info'>You must login as <b>admin</b> to use this operation!</p>".
				"<button class='button' onclick='window.close()'>Close</button>";
			exit;
		}
		$did = $_REQUEST['did'];

		$this->DOWNLOADS = new SQLiteDatabase("./$this->site/downloads.dbf");
		$q = @$this->DOWNLOADS->query("SELECT * FROM downloads WHERE did='$did'");
		if ($q === false)
		{
			echo "<p class='error'>Error reading database!</p>".
				"<button class='button' onclick='window.close()'>Close</button>";
			exit;
		}
		list($did,$name,$description,$location,$downloads,$datetime) = $q->current();
		
		$name = sqlite_escape_string(stripslashes($name));
		$description = sqlite_escape_string(stripslashes($description));
		$location = sqlite_escape_string(stripslashes($location));
		
		echo "<form action='admin.php' method='post'>".
			"<input type='hidden' name='dn' value='edit' />".
			"<input type='hidden' name='did' value='$did' />".
			"<div class='left'>Name:</div><div class='right'><input  name='name' value='$name' /></div>\n".
			"<div class='left'>Location:</div><div class='right'><input  name='location' value='$location' /></div>\n".
			"<div class='left'>Description:</div><div class='right'>".
			"<textarea name='desc' rows='' cols='' >$description</textarea><br />\n".
			"<input class='button' type='submit' value='Save' /> ".
			"</div>\n</form></body></html>";

		exit;
	}
	
        /*-------------------\
        | save download item |
        \-------------------*/
	function saveDnItem()
	{
		$this->DOWNLOADS = new SQLiteDatabase("./$this->site/downloads.dbf");
		$did   = $_POST['did'];
		$name  = sqlite_escape_string(stripslashes($_POST['name']));
		$loc   = sqlite_escape_string(stripslashes($_POST['location']));
		$desc  = sqlite_escape_string(stripslashes($_POST['desc']));

		$q = @$this->DOWNLOADS->query("UPDATE downloads SET Name='$name',Description='$desc',Location='$loc' WHERE did='$did'");

		echo "<html><head></head><body onload='window.opener.location=(\"?settings=downloads\");window.close()'></body></html>";
		exit;
	}
	
        /*---------------------\
        | update language list |
        \---------------------*/
	function updateLanguages()
	{
		if($_COOKIE['user']!="admin")
		{
			$this->content .= "<p color='info'>You must login as <b>admin</b> to use this operation.</p>";
			return;
		}
		if(isset($_POST['languages']))
		{
			$languages = rtrim($_POST['languages']);
			if($languages == "set")
			{
				$selected  = rtrim($_POST['selected']);
				if(!$selected) $selected = "en";
				$file = @fopen("$this->site/language", "w");
				if(!$file)
				{
					$this->content .= "<div class='error'>*** FATAL *** unable to open '$this->site/language' file!</div>".
						"<p>Please make sure read/write permissions are enabled!</p>";
					return;
				}
				fwrite($file, $selected);
				fclose($file);
				$this->content .= "<div class='success'>Default Language updated - ($selected)!</div>";
				return;
			}
			$file = @fopen("$this->site/languages.txt", "w");
			if(!$file)
			{
				$this->content .= "<div class='error'>*** FATAL *** unable to open 'languages' file!</div>".
					"<p>Please make sure read/write permissions are enabled!</p>";
				return;
			}
			fwrite($file, $languages);
			fclose($file);
			$this->content .= "<div class='success'>Language List updated!</div><h3>Languages Selection:</h3><pre>$languages</pre>";
			return;
		}
		$default_language = trim(@file_get_contents("$this->site/language"));
		if(!$default_language) $default_language = "en";
		$this_language = $_SESSION['language'];
		$languages = @file_get_contents("$this->site/languages.txt");
		$this->content .= "<h2>Language Selection List</h2>".
				  "<p><b/>Add/Remove Languages<b/></p>".
				  "<form action='admin.php' method='post'>".
				  "<input type='hidden' name='settings' value='languages' />\n".
				  "<textarea class='resize' name='languages' rows='15' cols='20'>$languages</textarea><br />".
				  "<input class='button' type='submit' value='Save' /></form>".
				  "<p>Format:<br /><code><i>code</i>|Language</code></p>";
		if($languages)
		{
			$this->content .= "<p>Current Default: $default_language</p><p>Selected: $this_language</p>".
					  "<p><form method='post' action='admin.php' >\n".
					  "<input type='hidden' name='settings' value='languages' />\n".
					  "<input type='hidden' name='languages' value='set' >\n".
					  "New Default Language: <select name='selected'>\n<option value=''>SELECT</option>";
			$languages = explode("\n",$languages);
			$num = count($languages);
			for($ix=0;$ix<$num;$ix++)
			{
				list($code,$language) = explode("|",$languages[$ix]);
				if(!$code) continue;
				$this->content .= "<option value='$code'>$language</option>\n";
			}
			$this->content .= "</select> <input class='button' type='submit' value='Go' style='width:40px' / ></form></p>";
		}
		return;
	}
	
        /*----------------\
        | update settings |
        \----------------*/
	function updateSettings()
	{
		$this->sub_menu = "<li><a href='?settings=update'>Site</a></li>".
				  "<li><a href='?settings=themes'>Themes</a></li>".
				  "<li><a href='?settings=languages'>Languages</a></li>".
				  "<li><a href='?settings=downloads'>Downloads</a></li>".
				  "<li><a href='?settings=password'>Password</a></li>";
		
		if($_REQUEST['settings']=="password")  return $this->changePassword();
		if($_COOKIE['user']!="admin")
		{
			$this->content .= "<p class='info'>You must login as <b>admin</b> to use this operation.</p>";
			return;
		}
		if($_REQUEST['settings']=="languages") return $this->updateLanguages();
		if($_REQUEST['settings']=="themes")    return $this->updateThemes();
		if($_REQUEST['settings']=="downloads") return $this->updateDownloads();
		
		if($_POST['settings']=="update")
		{
			$file = @fopen("$this->site$this->language/settings", "w");
			if(!$file)
			{
				$this->content .= "<div class='error'>*** FATAL *** unable to open 'settings' file!</div>".
					"<p>Please make sure read/write permissions are enabled!</p>";
				return;
			}
			$content = $_POST['title']."^^^".$_POST['slogan']."^^^".$_POST['copyright']."^^^".$_POST['meta']."^^^".$_POST['email'].
				   "^^^".$_POST['editor']."^^^".$_POST['uname']."^^^".$_POST['stype']."^^^".$_POST['html']."^^^";
			$content = stripslashes($content);
			fwrite($file, $content);
			fclose($file);
			$this->content .= "<div class='success'>Settings updated!</div>";
			return;
		}
		
		list($title,$slogan,$copyright,$meta,$email,$editor,$uname,$stype,$html) =
			explode("^^^",@file_get_contents("$this->site$this->language/settings"));

		if(!$title) $title = "$this->site Site Title";
		if(!$slogan) $slogan = "$this->site Site Slogan";
		if(!$copyright) $copyright = "&amp;copy; 2010 $this->site";
		if(!$meta) $meta = "<meta name=\"description\" content=\"wfiedler free web site templates\" />\n".
				   "<meta name=\"keywords\" content=\"wfiedler,free templates,wcms,w-cms\" />\n";
		$meta	   = stripslashes($meta);
		$title	   = preg_replace("/'/","&#39",$title);
		$slogan	   = preg_replace("/'/","&#39",$slogan);
		if($stype=="private") $private = "checked";
		else $public = "checked";
		if($html=="pname") $pname = "checked";
		elseif($html=="ptitle") $ptitle = "checked";
		elseif($html=="number") $number = "checked";
		$copyright = preg_replace("/'/","&#39",$copyright);
		$email	   = stripslashes($email);
		$uname	   = stripslashes($uname);
		if($editor=="ckeditor") $ckeditor = "checked";
		elseif($editor=="tinymce") $tinymce = "checked";
		elseif($editor=="nice") $nice = "checked";
		else $markup = "checked";

		if(is_dir("tinymce"))
		{
			$addon .= "<input style='width: 10px' type='radio' name='editor' value='tinymce' $tinymce /> _TinyMCE &nbsp; ";
		}
		if(is_dir("ckeditor"))
		{
			$addon .= "<input style='width: 10px' type='radio' name='editor' value='ckeditor' $ckeditor /> _CKEditor";
		}

		$this->content .= "<h2>Site Settings</h2><div id='settings'><div class='left'>".
				  "<p>Title</p><p>Slogan</p><p>Site Type</p><p>HTML</p><p>Copyright</p><p>E-mail</p>".
				  "<p>Name</p><p>Editor</p><p>Meta Tags</p></div><div class='right'>".
				  "<form action='admin.php' method='post'>".
				  "<input type='hidden' name='site' value='$this->site' />".
				  "<input type='hidden' name='settings' value='update' />".
				  "<p><input name='title' value='$title' /></p>".
				  "<p><input  name='slogan' value='$slogan' /></p>".
				  "<p><input style='width: 10px' type='radio' name='stype' value='public' $public /> _Public &nbsp; &nbsp;".
				  "<input style='width: 10px' type='radio' name='stype' value='private' $private /> _Private</p>".
				  "<p><input style='width: 10px' type='radio' name='html' value='' /> _None &nbsp; &nbsp;".
				  "<input style='width: 10px' type='radio' name='html' value='number' $number /> _Number &nbsp; &nbsp;".
				  "<input style='width: 10px' type='radio' name='html' value='pname' $pname /> _Name &nbsp; &nbsp;".
				  "<input style='width: 10px' type='radio' name='html' value='ptitle' $ptitle /> _Title</p>".
				  "<p><input name='copyright' value='$copyright' /></p>".
				  "<p><input name='email' value='$email' /></p>".
				  "<p><input name='uname' value='$uname' /></p>".
				  "<p><input style='width: 10px' type='radio' name='editor' value='markup' $markup /> _Markup &nbsp; ".
				  "$addon</p>".
				  "<textarea class='resize' style='height:120px' name='meta'>$meta</textarea><br />".
				  "<input class='button' style='width: auto;' type='submit' value='Save' /></form></div></div>";
		return;
	}
	
        /*----------------\
        | change password |
        \----------------*/
	function changePassword()
	{
		if($_POST['password1'])
		{
			$pw1 = trim($_POST['password1']);
			$pw2 = trim($_POST['password2']);
			if($pw1!=$pw2)
			{
				$this->content .= "<div class='error'>Passwords not matched!</div>";
				return;
			}
			$user = $_POST['user'];
			if($user=="admin") $user = "password";
			else $user = "member";
			
			$file = @fopen("$this->site/$user", "w");
			if(!$file)
			{
				$this->content .= "<div class='error'>*** FATAL *** unable to open 'password' file!</div>".
					"<p>Please make sure read/write permissions are enabled!</p>";
				return;
			}
			$pw1 = crypt($pw1,$this->site);
			fwrite($file, $pw1);
			fclose($file);
			$this->content .= "<div class='success'>Password changed!</div>";
			setcookie($this->cookie,'',time() - 86400); // remove cookie/password
			setcookie("user",'',time() - 86400); // remove cookie/password

			return;
		}
		$user = $_COOKIE['user'];
		$this->content .= "<h2>Change Password for $user:</h2>\n".
				  "<div id='settings'>\n".
				  "<form action='admin.php' method='post'>\n".
				  "<input type='hidden' name='settings' value='password' />\n".
				  "<input type='hidden' name='user' value='$user' />\n".
				  "<input type='hidden' name='site' value='$this->site' />\n".
				  "<div class='left'>\n".
				  "<p>New Password</p>\n".
				  "<p>Again</p>\n".
				  "</div>\n".
				  "<div class='right'>\n".
				  "<input type='password' name='password1' value='' />\n".
				  "<input type='password' name='password2' value='' /><br />\n".
				  "<input style='width: auto;' class='button' type='submit' value='Change' />".
				  "</div>\n</form></div>\n";
		return;
	}
	
	/*---------\
	| site map |
	\---------*/
	function siteMap()
	{
		$menus = @file_get_contents("$this->site$this->language/menus");
		
		$groups = explode("^^^",$menus);
		$gnum = count($groups);
		for($ix=0;$ix<$gnum;$ix++)
		{
			$this_groups = explode("\n",$groups[$ix]);
			$inum = count($this_groups); // get number of items in group 
			for($jx=$snum=0;$jx<$inum;$jx++)
			{
				$this->groups[$ix][$snum] = explode("|",$this_groups[$jx]);
				$sectnum = trim($this->groups[$ix][$snum][0]);
				if(!$sectnum || $sectnum<0) continue;
				list($name1,$sname) = explode(".",$this->groups[$ix][$snum][1]);
				if($sname)
				{
					if(!$parent)
					{
						$subnum = 0;
						$parent = $name1;
					}
					$this->subs[$pnum][$subnum] = $this->groups[$ix][$snum];
					$this->subs[$pnum][$subnum][1] = $sname;
					$subnum++;
					continue;
				}
				$parent = "";
				$pnum   = $sectnum;
				$snum++;
			}
		}

		$this->content .= "<h2>Site Map</h2>\n";
		$num = count($this->groups);
		for($ix=0;$ix<$num;$ix++)
		{
			if(!trim($this->groups[$ix][0][0])) continue;

			$this->content .= "<h3>Group $ix</h3>\n";
			$this->getSiteMap($this->groups[$ix]);
		}
	}
	
	/*-------------\
	| get site map |
	\-------------*/
	function getSiteMap($group)
	{
		$this->content .= "<ul>";
		$gnum = count($group);
		for($jx=0;$jx<$gnum;$jx++)
		{
			if(!trim($group[$jx][0])) continue;
			$pnum = $group[$jx][0];
			if($pnum<0) continue;
			$ext = "";
			$theme = $group[$jx][4];
			if($group[$jx][4]=="redirect")
			{
				$ext = " - Redirect to ".$group[$jx][5];
			}
			
			$this->content .= "<li><a href='index.php?p=$pnum'>".$group[$jx][1]."</a> - ".$group[$jx][2].$ext;
			if($this->subs[$pnum])
			{
				$this->displayMap($this->subs[$pnum]);
			}
			$this->content .= "</li>\n";
		}
		$this->content .= "</ul><br />\n";
	}
	
	/*-------------------------\
	| get page/section content |
	\-------------------------*/
	function getContent($type,$num)
	{
		if($type=="public")
		{
			$content = @file_get_contents("public/public-$num");
		}
		elseif( file_exists("$this->site$this->language/$type-$num") )
		{
			$content = @file_get_contents("$this->site$this->language/$type-$num");
		}
		else // add default content if new
		{
			$content = "<b>$type - content $num</b><p>Lorem ipsum dolor sit amet, ".
				"consectetuer sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut ".
				"labore et dolore magna aliquyam erat, sed diam voluptua.</p>";
		}
		return $content;
	}
	
        /*---------------------\
        | show folders listing |
        \---------------------*/
	function showFoldersListing($nitems,$folders)
	{
		echo "<div class='show_hide'>";
		
		for($ix=0;$ix<$nitems;$ix++)
		{
			list($folder,$desc) = explode("|",$folders[$ix]);
			if(!$folder) continue;
			$files  = explode("\n",@file_get_contents("$this->site/files/$folder/files"));
			$nfiles = count($files);
			if($nfiles<2)
			{
				echo "<p class='error'>There are no files in <b>$folder</b> folder!</p>";
				continue;
			}
			echo "<div><img src='images/folder.png' alt='Folder' /><b>$folder</b> - $desc".
					" <a href='#' id='note$ix' class='comment' name='note$ix$'>[+/- Files]</a></div>".
					"<div id='textboxnote$ix' style='display:none;'>";
			for($jx=0;$jx<$nfiles;$jx++)
			{
				list($fname,$desc) = explode("|",$files[$jx]);
				if(!$fname) continue;
				$ext = strtolower(substr(strrchr($fname, '.'), 1));
				if($ext == "gif" || $ext == "jpg" || $ext == "png" || $ext == "bmp")
				{
					$img = "Copy and paste Code Image:<br /><input type='text' id='img$ix$jx' onClick=\"SelectAll('img$ix$jx');\" ".
					"value = \"&lt;img src='./$this->site/files/$folder/$fname' alt='Photo' />\"<br />";
				}
				else	$img = "";
				echo "\n<div class='file'><img src='./images/$ext.png' alt='&#9658;' /> $fname <a href='#' id='note$ix$jx' class='comment' name='note$ix$jx'>[+/- HTML]</a></div>".
					"<div id='textboxnote$ix$jx' class='textbox' style='display:none'>\n$img".
					"Copy and paste Code Link:<br /><input type='text' id='$ix$jx' onClick=\"SelectAll('$ix$jx');\" \n".
					"value = \"&lt;a href='./$this->site/files/$folder/$fname'>$fname&lt;/a>\" /></div>";
			}
			echo "</div><hr />\n";
		}
		echo "</div>\n";
	}
	
        /*--------------------\
        | show albums listing |
        \--------------------*/
	function showAlbumsListing($nalbm,$albums)
	{
		echo "<div class='show_hide'>";
		for($ix=0;$ix<$nalbm;$ix++)
		{
			list($album,$desc) = explode("|",$albums[$ix]);
			if(!$album) continue;
			$photos = explode("\n",@file_get_contents("$this->site/$album/photos"));
			$nitems = count($photos);
			echo "<div><img src='images/camera.png' alt='Folder' /><b>$album</b> - $desc".
				" <a href='#' id='album$ix' class='comment' name='album$ix$'>[+/- Files]</a></div>".
				"<div id='textboxalbum$ix' style='display:none;'>";
			for($jx=0;$jx<$nitems;$jx++)
			{
				list($fname,$desc,$hide) = explode("|",$photos[$jx]);
				if(!$fname) continue;
				echo "\n<div class='photos'><img src='./$this->site/$album/_$fname' style='width: 30px; height: auto; margin: 0 5px 0 0;' alt='Photo' />".
					" <a href='#' id='album$ix$jx' class='comment' name='album$ix$jx'>[+/- HTML]</a></div>".
					"<div id='textboxalbum$ix$jx' class='textbox' style='display:none'>\n".
					"Copy and paste Code Image:<br /><input type='text' id='img1$ix$jx' onClick=\"SelectAll('img1$ix$jx');\" ".
					"value = \"&lt;img src='./$this->site/$album/$fname' alt='Photo' />\"<br />".
					"Copy and paste Code Link:<br /><input type='text' id='1$ix$jx' onClick=\"SelectAll('1$ix$jx');\" \n".
					"value = \"&lt;a href='./$this->site/$album/$fname'>$fname&lt;/a>\" /></div>";
			}
			echo "</div><hr />\n";
		}
		echo "</div></div>\n";
	}
	
        /*----------\
        | edit page |
        \----------*/
	function editPage($type,$id)
	{
		$content = $this->getContent($type,$id);
		
		$content = preg_replace("/&([a-zA-Z]+);/","&amp;$1;",$content);
		$content = preg_replace("/<\/textarea/i","&lt;/textarea",$content);
		echo 
"<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>
<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en'>
<head>
<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />
<title>w-CMS - Markup Editor</title>
<link rel='stylesheet' type='text/css' href='css/markup.css' />
<script type='text/javascript' src='js/jquery.js'></script>
<script type='text/javascript' src='js/ed_wcms.js'></script>
<script type='text/javascript' src='js/jquery.tipsy.js'></script>
<script type='text/javascript'>
  $(function() {
    
    $('.tip').tipsy({fade: true});
  });
</script>
</head>
<body>

<div id='wrapper'>
<table><tr><td valign='top'>
<div id='editor'>
<h4>Edit Content: <span class='page'>$type $id</span></h4>
<div id='buttons'>
<script type='text/javascript'>edToolbar('textfield');</script>
<form name='form' action='./codes/updatecontent.php' method='post'>
<input type='hidden' name='fieldname' value='$type-$id' />
<input type='hidden' name='id' value='$id' />
<input type='hidden' name='site' value='$this->site' />
<input type='hidden' name='theme' value='$this->theme' />
<input type='hidden' name='language' value='$this->language' />
<textarea name='htmlArea' id='textfield' class='ed' cols='60' rows='10'>$content</textarea>
<input class='button' type='submit' value='Save' />
<input class='button' type='button' value='Cancel' onClick='window.close()'>
</form>
<div id='title'>w-CMS Markup Editor</div>
</div>
</td><td valign='top'>";
		$show_hide = "$this->show_hide<h4>Uploaded Files:</h4><div id='iframe'>";
		
		$folders = explode("\n",@file_get_contents("$this->site/folders"));
		$nitems  = count($folders);
		if($nitems<2)
		{
			echo "<p class='info'>No files in folder!</p>";
		}
		else
		{
			echo $show_hide;
			$this->showFoldersListing($nitems,$folders);
			$show_hide = "";
		}
		$albums  = explode("\n",@file_get_contents("$this->site/albums"));
		$nitems = count($albums);
		if($nitems>1)
		{
			echo $show_hide;
			echo "<h4>Photo Albums:</h4>";
			$this->showAlbumsListing($nitems,$albums);
		}
		echo "</div></td></tr></table></div></body></html>";
		exit;
	}
		
        /*----------\
        | edit page |
        \----------*/
	function editPageTinyMCE($type,$id)
	{
		if(! is_dir("tinymce")) return $this->editPage($type,$id);
		
		$content = $this->getContent($type,$id);
		
		$content = preg_replace("/<\/textarea/i","&lt;/textarea",$content);
		echo "
<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en'>
<head>
<title>wCMS - TinyMCE</title>
<meta content='text/html; charset=utf-8' http-equiv='content-type' />
<script type='text/javascript' src='./tinymce/jscripts/tiny_mce/tiny_mce.js'></script>
<script type='text/javascript'>
	tinyMCE.init({
		mode : \"textareas\",
		theme : \"advanced\",
		plugins : \"pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,wordcount,advlist,autosave\",
		theme_advanced_buttons1: \"formatselect,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,bullist,numlist,|,outdent,indent,blockquote,hr,|,undo,redo,|,link,unlink,anchor,cleanup,code,|,image\",
		theme_advanced_buttons2 : \"\",
		theme_advanced_buttons3 : \"\",
		theme_advanced_buttons4 : \"\",
		theme_advanced_toolbar_location : \"top\",
		theme_advanced_toolbar_align : \"left\",
		theme_advanced_statusbar_location : \"bottom\",
		theme_advanced_resizing : true,
		// Skin options
        skin : \"o2k7\",
        skin_variant : \"silver\"
	});
</script>
<link rel='stylesheet' type='text/css' href='./css/markup.css' />
</head>
<body>
<div style='padding:10px 10px 10px 10px'>
<h3>Edit Content - $type $id</h3>
<form name='form' action='./codes/updatecontent.php' method='post'>
<input type='hidden' name='fieldname' value='$type-$id' />
<input type='hidden' name='id' value='$id' />
<input type='hidden' name='site' value='$this->site' />
<input type='hidden' name='theme' value='$this->theme' />
<input type='hidden' name='language' value='$this->language' />
<textarea id='html' name='htmlArea'  style='width: 99%;height: 330px;' >$content</textarea><br />
<input class='button' type='submit' value='Save' />
<input class='button' type='button' value='Cancel' onClick='window.close()'>
</form>
</div>
</body>
</html>";
	 exit;
	}

        /*----------\
        | edit page |
        \----------*/
	function editPageCKEditor($type,$id)
	{
		if(! is_dir("ckeditor")) return $this->editPage($type,$id);
		
		$content = $this->getContent($type,$id);
		
		$content = preg_replace("/<\/textarea/i","&lt;/textarea",$content);
		echo "
<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
<!--
Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
For licensing, see LICENSE.html or http://ckeditor.com/license
-->
<html xmlns='http://www.w3.org/1999/xhtml'>
<head>
<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />
<title>CKEditor</title>
<meta content='text/html; charset=utf-8' http-equiv='content-type' />
<script type='text/javascript' src='./ckeditor/ckeditor.js'></script>
<script type='text/javascript'>
CKEDITOR.replace( 'editor1',
    {
        toolbar : 'Full',
        uiColor : '#9AB8F3'
    });
</script>
</head>
<body>
<div style='padding:10px 10px 10px 10px'>
<h4>Edit Content - $type $id</h4>
<form name='form' action='./codes/updatecontent.php' method='post'>
<input type='hidden' name='fieldname' value='$type-$id' />
<input type='hidden' name='id' value='$id' />
<input type='hidden' name='site' value='$this->site' />
<input type='hidden' name='theme' value='$this->theme' />
<input type='hidden' name='language' value='$this->language' />
<p>
   <label for='editor1'>
      <textarea name='htmlArea' class='ckeditor' id='editor1'>$content</textarea>
</p>
<p>
   <input class='button' type='submit' value='Save' />
   <input class='button' type='button' value='Cancel' onClick='window.close()'>
</p>
</form>
</div>
<div style='text-align: center'>CKEditor - <a href='http://ckeditor.com/'>http://ckeditor.com</a> | Copyright 2003-2010 <a href='http://cksource.com/'>CKSource</a> Frederico Knabben. All rights reserved.</p>

</body>
</html>
";
	 exit;
	}

        /*-----------------\
        | manage templates |
        \-----------------*/
	function manageTemplates()
	{
		if($_COOKIE['user']!="admin")
		{
			$this->content .= "<p class='info'>You must login as <b>admin</b> to use this operation.</p>";
			return;
		}
		$this->sub_menu = "<li><a href='?templates'>Templates</a></li>".
				  "<li><a href='?templates=update'>Update</a></li>";

		$this->content .= "<p class='info'>This function is under construction...</p>";
		
		if($_REQUEST['templates'] =="update")   return $this->updateTemplate($_REQUEST['tpl'],$_REQUEST['desc']);
		if($_REQUEST['templates'] =="listing")  return $this->templatesListing();
		if($_REQUEST['templates'] =="delete")   return $this->deleteTemplate($_REQUEST['tpl']);

		if(!$_REQUEST['templates'])  return $this->templateListing();
		
		if($_POST['delete'])
		{
			$tpl = $_POST['delete'];
			$content = "";
			$items   = explode("\n",@file_get_contents("./templates/$this->site/templates"));
			$num     = count($items);
			for($ix=0;$ix<$num;$ix++)
			{
				list($name,$desc) = explode("|",$items[$ix]);
				if($name==$tpl || !$name) continue;
				$content .= "$name|$desc\n";
			}
			$file = @fopen("./templates/$this->site/templates", "w");
			fwrite($file, $content);
			fclose($file);
			
			$this->templateListing();
			return;
		}
		$this->content .= "<div class='info'>Please selection an operation.</div>";
	}
	
        /*----------------\
        | update template |
        \----------------*/
	function updateTemplate($tpl,$desc)
	{
		$template = $_REQUEST['newtpl'];
		$desc     = $_REQUEST['desc'];
		if($_POST['templates'])
		{
			if(is_dir("./templates/$this->site/$template/"))
			{
				$file = @fopen("./templates/$this->site/templates", "a");
				fwrite($file, "$template|$desc\n");
				fclose($file);
			
				$this->content .= "<div class='success'>Template <b>$template</b> added!</div>";
				$this->templateListing();
				return;
			}
			$this->content .= "<div class='error'>Design <b>$template</b> not found!</div>";
		}
		$templates = explode("\n",@file_get_contents("./templates/$this->site/templates"));
		$nitems = count($templates);
		$this->content .= "<div id='settings'><form action='admin.php' method='post'>".
				  "<input type='hidden' name='templates' value='update' />".
				  "<h2>Update Template</h2>".
				  "<div class='left'>\n<p>Template</p><p>Description</p></div>".
				  "<div class='right'>".
				  "<input name='newtpl' value='$template' />".
				  "<input name='desc' value='$desc' /><br />".
				  "<input style='width: auto;' class='button' type='submit' value='Add' /><br />".
				  "<select name='remove'><option value=''>SELECT</option>";
		for($ix=0;$ix<$nitems;$ix++)
		{
			list($name) = explode("|",$templates[$ix]);
			if(!$name) continue;
			$this->content .= "<option value='$name'>$name</option>";
		}
		$this->content .= "</select> <input style='width: auto;' class='button' type='submit' value='Remove' title='Remove selected Template' /></form><br />".
				  "<div class='info'>WARNING: Template removed CANNOT be recovered!</div></div></div>";
	}
	
        /*-----------------\
        | append Activity  |
        \-----------------*/
        function miscActivity($action,$type,$name,$link)
        {
		list($second,$minute,$hour,$day,$month,$year) = localtime(time());
                $date = sprintf("%d/%02d/%02d %02d:%02d",$year+1900,$month+1,$day,$hour,$minute);

		$uname = $_COOKIE['uname'];
		$content = "$date\0xff $this->site\0xff $uname\0xff $action\0xff $type\0xff $name\0xff $link\n";

		$this->saveActivity("misc",$content);
		$this->saveActivity("all","misc\0xff $content");
        }
	
        /*---------------\
        | save activity  |
        \---------------*/
        function saveActivity($type,$current)
        {		
		$data = explode("\n",@file_get_contents("./public/$type"));

		$file = @fopen("./public/$type", "w");
		if(!$file) return;
		
		fwrite($file, $current);
		for($ix=0;$ix<25;$ix++)
		{
			fwrite($file,$data[$ix]."\n");
		}
		fclose($file);
        }

        /*---------------------\
        | process HTML pages  |
        \---------------------*/
        function processHTML($action)
        {
		$prefix = "";
		if($this->site != "main") $prefix = "$this->site-";
		
		list($title,$slogan,$copyright,$meta,$email,$editor,$uname,$stype,$ptype) =
			explode("^^^",@file_get_contents("$this->site$this->language/settings"));

		$ptype = trim($ptype);
		if(!$ptype)
		{
			$this->content .= "<div class='error'>This function is currently disabled!</div>";
			return;
		}
		$menus = explode("\n",@file_get_contents("$this->site$this->language/menus"));
		$num   = count($menus);
	
		$del = $gen = $skip = 0;
		for($ix=0;$ix<$num;$ix++)
		{
			list($pnum,$pname,$ptitle,$attrs,$theme,$type,$lf) = explode("|",$menus[$ix]);
			if(!$ptitle) continue;
			list($pname,$subpage) = explode(".",$pname);
			if($subpage) $pname = $subpage;
			$pname = trim($pname);

			if($ptype=="pname") $html = $pname;
			elseif($ptype=="ptitle")
			{
				list($name,$html) =  explode("^",$ptitle);
				if(!$html) $html = $name;
			}
			else $html = $pnum;
			
			if($action == "remove")
			{
				$fname = "$prefix$html.html";
				if( file_exists($fname) )
				{
					if(unlink($fname))
					{
						$this->content .= "<p><b>$fname</b> deleted!</p>";
						$del++;
					}
					else
					{
						$this->content .= "<p style='color:red'>Delete <b>$fname</b> failed!</p>";
						$skip++;
					}
				}
				continue;
			}
			$type = trim($type);
			
			if(!$type || $type=="static" || substr($type,0,7)=="gallery")
			{
				file_get_contents("$this->host/index.php?p=$pnum&site=$this->site&generate=html");
				$gen++;
				$this->content .= "<p><a href='$prefix$html.html'>$prefix$html.html</a> generated</p>";
				continue;
			}
			$skip++;
			$this->content .= "<p style='color:red'><a href='$prefix$html.html'>$prefix$html.html</a> skipped</p>";
			$content = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n".
				   "<html>\n<head>\n<title>$this->site: Page $ix - $pname</title>".
				   "<meta http-equiv=\"REFRESH\" content=\"0;url=index.php?p=$pnum\">\n".
				   "</head>\n<body>\n</body>\n</html>\n";
			$file = @fopen("$prefix$html.html", "w");
			if($file)
			{
				fwrite($file, $content);
				fclose($file);
			}
		}
		if($action == "remove")
		{
			if(unlink($prefix."sitemap.html"))
			{
				$this->content .= "<p><b>$prefix"."sitemap.html</b> deleted!</p>";
				$del++;
			}
			$this->content .= "<div class='success'>$del HTML pages deleted!</div>";
			if($skip) $this->content .= "<div class='error'>$skip pages failed to delete!</div>";
		}
		else
		{
			$html = "sitemap";
			$this->content .= "<p><a href='$prefix$html.html'>$prefix$html.html</a> generated</p>";
			file_get_contents("$this->host/index.php?p=sitemap&site=$this->site&generate=html");
			$gen++;
			$this->content .= "<div class='success'>$gen HTML pages generated!</div>";
			if($skip) $this->content .= "<div class='error'>$skip pages skipped!</div>";
		}
		return;
        }
	
        /*-------------\
        | popup window |
        \-------------*/
        function popupWindow($url,$width,$height,$title)
        {
		return "<a href='#' onclick=\"OpenNewWindow('$url','$width','$height','Loading');\" > $title </a>";
        }

}
?>