<?php
   
class wCMS extends localFunctions
{
	/*---------------------------\
	| initialize content objects |
	\---------------------------*/
	function wCMS($site)
	{
		if($_REQUEST['vfy_image']) return $this->vfyImage();
		
		$this->configSection($site);
		$this->logout();
		
		$this->getSettings();
		if($this->stype=="private")
		{
			if(! $_COOKIE[$this->cookie] || $_COOKIE['mysite']!=$this->site)
			{
				header('Location: ./admin.php?login');
				exit;
			}
		}
		if($_REQUEST['download'])
		{
			$this->fileDownload();
		}
		
		$this->localFunctions();
		$this->getStatus();

		if($_REQUEST['theme'])
		{
			$this->theme = $_REQUEST['theme'];
			if($_COOKIE['mysite']==$this->site)
			{
				$file = @fopen("$this->site$this->language/theme", "w");
				if(!$file)
				{
					echo "<div class='error'>*** FATAL *** unable to save theme in $this->site!</div>".
						"<p>Please make sure read/write permissions are enabled!</p>";
					exit;
				}
				fwrite($file, $this->theme);
				fclose($file);
			}
		}
		if($_REQUEST['thm'])
		{
			$this->theme = $_REQUEST['thm'];
		}
		if( !$this->theme ) $this->theme = @file_get_contents("$this->site$this->language/theme");

		if( !file_exists("$this->theme.php") ) $this->theme = "./templates/default";

		$prefix = "";
		if($this->site != "main") $prefix = "$this->site-";
			
		if($this->page=="sitemap") $pname = "$prefix"."sitemap.html";
		elseif($this->html == "pname") $pname = $prefix.$this->menus[$this->page][0].".html";
		elseif($this->html == "ptitle")
		{
			list($name,$title) = explode("^",$this->menus[$this->page][1]);
			if(!$title) $title = $name;
	
			$pname = "$prefix$title.html";
		}
		else $pname = "$prefix$this->page.html";
		if($_REQUEST['generate'] && $this->html)
		{
			ob_start();
		}
		elseif($_COOKIE['mysite']!=$this->site)
		{
			$len = @filesize($pname);
			if($len>500)
			{
				header("Location: ./$pname");
				exit;
			}
		}	
		
		require("$this->theme.php");

		if($_REQUEST['generate'] && $this->html)
		{
			$content = ob_get_contents();
			$content = preg_replace("/\?p=sitemap/",$prefix."sitemap.html",$content);
			$content = preg_replace("/\?p=(\d+)/e","\$this->getPageName('\\1')",$content);
			$content = preg_replace("/(\"|\')\?/","$1"."index.php?",$content);
			
			$file = @fopen($pname, "w");
			if($file)
			{
				fwrite($file, $content);
				fclose($file);
			}
		}
	}
	
	/*---------------\
	| config section |
	\---------------*/
	function configSection($site)
	{
		error_reporting(E_ERROR|E_PARSE);
		$this->cookie = 'wcms';	// cookie name
		$this->etime = time()+86400; // expire time
		
		if($_REQUEST['set']=="clear")
		{
			$_SESSION['site'] = "";
			$this->clearCookies();			
			header('Location: ./');
		}
		$this->site = $site;
		if(!$this->site)
		{
			$this->site = "main"; // if site is not specified, use main
		}
		$this->getLanguages();
		$this->pass_admin = @file_get_contents("$this->site/password");
		if(!$this->pass_admin)
		{
			$this->pass_admin = crypt("admin",$this->site);
			$file = @fopen("$this->site/password", "w");
			if(!$file)
			{
				echo "<div class='error'>*** FATAL *** unable to save password in $this->site!</div>".
						"<p>Please make sure read/write permissions are enabled!</p>";
				exit;
			}
			fwrite($file, $this->pass_admin);
			fclose($file);
		}
		$this->pass_member = @file_get_contents("$this->site/member");
		if(!$this->pass_member)
		{
			$this->pass_member = crypt("member",$this->site);
			$file = @fopen("$this->site/member", "w");
			if(!$file)
			{
				echo "<div class='error'>*** FATAL *** unable to save password in $this->site!</div>".
						"<p>Please make sure read/write permissions are enabled!</p>";
				exit;
			}
			fwrite($file, $this->pass_member);
			fclose($file);
		}
		foreach($_REQUEST as $key=>$val)
		{
			$this->_wcms_[$key] = stripslashes($val);
		}
                $this->_wcms_['datetime'] = time();
	}

        /*--------------\
        | get page name |
        \--------------*/
        function getPageName($pnum)
        {
		$prefix = "";
		if($this->site != "main") $prefix = "$this->site-";
		
		if($this->html == "pname") return $prefix.$this->menus[$pnum][0].".html";
		if($this->html == "ptitle")
		{
			list($name,$title) = explode("^",$this->menus[$pnum][1]);
			if(!$title) $title = $name;
			return "$prefix$title.html";
		}
		return "$prefix$pnum.html";
        }
	
	/*-----------------------\
	| get language selection |
	\-----------------------*/
	function getLanguages()
	{
		$languages = @file_get_contents("$this->site/languages.txt");
		if($languages)
		{
			$language = $_REQUEST['l'];
			if(!$language )
			{
				$default_language = trim(@file_get_contents("$this->site/language"));
				if($default_language)
				{
					$language = $_SESSION['language'];
					if(!$language)
					{
						$language = $default_language;
						$_SESSION['language'] = $language;
					}
				}
			}
			if(!$language ) $language = "en";
			$_SESSION['language'] = $language;
			if( $language!="en" )
			{
				if(! is_dir("$this->site/$language"))
				{
					echo "<div class='error'>*** FATAL *** unable to open language ($language)!</div>".
						"<p>Please go to <a href='admin.php?l=$language'>cPanel</a> to fix the problem!</p>";
					exit;
				}
				$this->language = "/$language";
			}
			$llist = explode("\n",$languages);
			$nlist = count($llist);
			for($ix=0;$ix<$nlist;$ix++)
			{
				list($lid,$lname) = explode("|",$llist[$ix]);
				if(!$lid) continue;
				if($lid == $language)
				{
					$did   = $lid;
					$dname = $lname;
				}
				$select .= "<option value='$lid' title='flags/$lid.png'>$lname</option>\n";
			}
			$this->languages = "<link rel='stylesheet' type='text/css' href='css/dd.css' />\n".
					   "<script type='text/javascript' src='js/jquery.js'></script>\n".
					   "<script type='text/javascript' src='js/jquery.dd.js'></script>\n".
					   "<div id='language'><form method='post' action='index.php'>\n".
					   "<select name='l' id='languages' style='width:150px; line-height: normal;'>\n".
					   "<option value='$language' title='flags/$language.png'>$dname</option>\n".
					   "$select</select><input class='dd-button' type='submit' value='&#9658;' /></form></div>".
					   "<script language='javascript' type='text/javascript'>\n".
					   "function showvalue(arg){alert(arg);}\n".
					   "$(document).ready(function(){\n".  
					   "try {\noHandler = $(\"#languages\").msDropDown().data(\"dd\");\n".
					   "$(\"#ver\").html($.msDropDown.version);\n".
					   "}\ncatch (e) {\nalert(\"Error: \" + e.message);\n}\n})\n</script>\n";

		}
		else $this->language = "";
	}
	
	/*----------------------\
	| get settings contents |
	\----------------------*/
	function getSettings()
	{
		list($this->title,$this->slogan,$this->copyright,$meta,$this->_wcms_['email'],
		     $this->editor,$this->_wcms_['uname'],$this->stype,$this->html) =
			explode("^^^",@file_get_contents("$this->site$this->language/settings"));

		$this->width  = 800;
		$this->height = 500;
		if(!$this->editor || $this->editor=="markup")
		{
			$this->width  = 960;
			$this->height = 480;
		}
		if($_COOKIE['user']=="member")
		{
			if(is_dir("ckeditor") || is_dir("tinymce"))
			{
				$this->width  = 800;
				$this->height = 500;
			}
		}
		if(!$this->title) $this->title = "$this->site Site Title";
		if(!$this->slogan) $this->slogan = "<b>$this->site</b> Site Slogan";
		if(!$this->copyright) $this->copyright = "&amp;copy; 2011 $this->site";
		
		$this->meta .= stripslashes($meta);
		
		/*$this->meta .= stripslashes($meta).
			       "<script type='text/javascript' src='js/swfobject.js'></script>\n".
			       "<script type='text/javascript' src='js/jquery.ytchromeless.min.js'></script>\n".
			       "<script type='text/javascript'>\n".
			       "$(document).ready(function() {\n".
			       "$('a.video-link').ytchromeless();\n});\n</script>\n";*/

		$this->getAlbums();
		$this->getMenus();
		$this->sections = explode("\n",@file_get_contents("$this->site$this->language/sections"));

		if($_COOKIE[$this->cookie])
		{
			$this->meta .= "\n<script language='javascript' type='text/javascript'>\n".
			       "var win= null;\n".
			       "function OpenNewWindow(mypage,w,h,myname){\n".
			       "var winl = (screen.width-w)/2;\n".
			       "var wint = (screen.height-h)/2;\n".
			       "settings='height='+h+',width='+w+',top='+wint+',left='+winl+',scrollbars=no,toolbar=no'\n".
			       "win=window.open(mypage,myname,settings)\n".
			       "if(parseInt(navigator.appVersion) >= 4){win.window.focus();}\n".
			       "}\n".
			       "</script>\n";
		}
		if($this->ptype=="blog")
		{
			$this->meta .= "<style type='text/css'>\n".
				       ".paginationLeft, .paginationRight {\n".
				       "float: left;\n".
				       "margin: 0 0 16px 0;\n".
				       "width: 50%;\n".
				       "}\n".
				       ".paginationLeft { text-align: left; }\n".
				       ".paginationRight { text-align: right; }\n".
				       ".topic {\n".
				       "border-top: 1px solid #ccc;\n".
				       "float: left;\n".
				       "width: 100%;\n".
				       "margin: 0 0 20px 0;\n".
				       "padding: 10px 0 0 0;\n".
				       "}\n</style>";
		}
	}
	
	/*---------------------\
	| display main content |
	\---------------------*/
	function displayMainContent($page)
	{
		if($this->login_msg)
		{
			echo $this->login_msg;
			return;
		}
		if($_REQUEST['p']=="sitemap")
		{
			return $this->siteMap("");
		}
		if($_REQUEST['p']=="sites")
		{
			return $this->sitesListing();
		}
		if(!$_REQUEST['generate'] && $_COOKIE['mysite']==$this->site)
		{
			echo $this->popupWindow("admin.php?edit=$page&type=page",$this->width,$this->height,
				"<img src='./css/pencil.png' title='Click here to edit page $page' alt='Edit Content'/>");
		}
		if($_REQUEST['p']=="mail" || $this->ptype=="mail")
		{
			return $this->procMail();
		}
	        $content = $this->getContent("page",$page);
		
		echo preg_replace("/{(.*?)}/e","\$this->patReplace('\\1')",$content);

		if($this->ptype)
		{
			$ptype = $this->ptype;
			if(substr($ptype,0,7)=="gallery") $ptype = "gallery";
			switch($ptype)
			{
				case 'static' :		break;
				case 'templates' :	return $this->procTemplates();
				case 'forum' :		return $this->procForum("p_$this->page");
				case 'guestbook' :	return $this->procGuestbook();
				case 'blog' :
				case 'news' :		return $this->procBlog();
				case 'gallery' :	return $this->procGallery();
				case 'latest' :		return $this->latestActivity();
				case 'download' :	return $this->fileDownload();
				case 'myfunction':
					list($func,$parms) = explode(':',$this->myfunction);
					$parms = explode(',',$parms);
					return $this->$func($parms[0],$parms[1],$parms[2]);

				default : echo "$this->ptype is under construction...";
					  return;
			}
		}
	}
	
	/*------------------------\
	| display section content |
	\------------------------*/
	function displaySectionContent($sectnum)
	{
		$content = $this->getContent("section",$sectnum);
		if(!$_REQUEST['generate'] && $_COOKIE['mysite']==$this->site)
		{
			echo $this->popupWindow("admin.php?edit=$sectnum&type=section",$this->width,$this->height,
				"<img src='./css/pencil.png' title='Click here to edit section $sectnum' alt='Edit Content'/>");
		}
		echo $content;
	}
	
	/*-----------------------\
	| display public content |
	\-----------------------*/
	function displayPublicContent($sectnum)
	{
		$content = $this->getContent("public",$sectnum);
		if(!$_REQUEST['generate'] && $_COOKIE['mysite']==$this->site)
		{
			echo $this->popupWindow("admin.php?edit=$sectnum&type=public",$this->width,$this->height,
				"<img src='./css/pencil.png' title='Click here to edit public section $sectnum' alt='Edit Content'/>");
		}
		echo $content;
	}
	
	/*-------------------------\
	| get page/section content |
	\-------------------------*/
	function getContent($type,$num)
	{
		if($type=="public")
		{
			$content = @file_get_contents("public/public-$num");
		}
		elseif( file_exists("$this->site$this->language/$type-$num") )
		{
			$content = @file_get_contents("$this->site$this->language/$type-$num");
		}
		else // add default content if new
		{
			$content = "<b>$type - $num</b><p>Lorem ipsum dolor sit amet, ".
				"consectetuer sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut ".
				"labore et dolore magna aliquyam erat, sed diam voluptua.</p>";
		}
		return $content;
	}
	
	/*--------------\
	| logout stuff  |
	\--------------*/
	function logout()
	{
		if (!isset($_REQUEST['logout'])) return;
		$this->clearCookies();
		header('Location: ./'); // redirect the browser to original URL
	}
	
	/*---------------\
	| clear cookies  |
	\---------------*/
	function clearCookies()
	{
		setcookie($this->cookie,''); // remove cookie/password
		setcookie("user",''); // remove cookie/password
		setcookie("uname",''); // remove cookie/password
		setcookie("mysite",''); // remove cookie/password
		
		$_COOKIE[$this->cookie] = $_COOKIE['user'] = $_COOKIE['uname'] = $_COOKIE['mysite'] =
		$_REQUEST[$this->cookie] = $_REQUEST['user'] = $_REQUEST['uname'] = $_REQUEST['mysite'] = "";
	}
	
        /*-----------\
        | get albums |
        \-----------*/
	function getAlbums()
	{
		if(! file_exists("$this->site/albums") )
		{
			$file = @fopen("$this->site/albums", "w");
			if(!$file)
			{
				echo "<div class='error'>*** FATAL *** unable to create albums in $this->site!</div>".
						"<p>Please make sure read/write permissions are enabled!</p>";
				exit;
			}
			fclose($file);
		}
		$albums = explode("\n",@file_get_contents("$this->site/albums"));
		$gnum   = count($albums);
		for($ix=0;$ix<$gnum;$ix++)
		{
			$this->albums[$ix] = explode("\n",$albums[$ix]);
		}
	}
	
	/*----------------------\
	| get menus and contents|
	\----------------------*/
	function getMenus()
	{
		$this->_wcms_['this_page'] = $this->page = $_REQUEST['p'];
		$menus = @file_get_contents("$this->site$this->language/menus");
		if(!$menus)
		{	// content number | name | title | attributes | theme |
			$file = @fopen("$this->site$this->language/menus", "w");
			if(!$file)
			{
				echo "<div class='error'>*** FATAL *** unable to save menus in $this->site!</div>".
						"<p>Please make sure read/write permissions are enabled!</p>";
				exit;
			}
			$menus = "1|Home|Home_page|||\n^^^\n";
			fwrite($file, $menus);
			fclose($file);
		}
		
		$groups = explode("^^^",$menus);
		$gnum = count($groups);
		for($ix=0;$ix<$gnum;$ix++)
		{
			$this_groups = explode("\n",$groups[$ix]);
			$inum = count($this_groups); // get number of items in group 
			for($jx=$snum=0;$jx<$inum;$jx++)
			{
				$this->groups[$ix][$snum] = explode("|",$this_groups[$jx]);
				$sectnum = trim($this->groups[$ix][$snum][0]);
				if(!$sectnum) continue;
				if($sectnum<0)
				{
					if(!$_COOKIE[$this->cookie]) continue;
					$sectnum *= -1;
				}
				
				list($this->menus[$sectnum][0],$subpage) = explode(".",stripslashes(trim($this->groups[$ix][$snum][1])));
				if($subpage) $this->menus[$sectnum][0] = $subpage;
				$this->menus[$sectnum][1] = trim($this->groups[$ix][$snum][2]);
				
				if(!$this->page)
				{
					$this->page = $sectnum;
				}
				if($this->page==$sectnum)
				{
					$pset = 1;
					$curr = $snum;
					if($this->groups[$ix][$snum][5]=="redirect")
					{
						header("Location: ".$this->groups[$ix][$snum][6]);
						exit;
					}
					$this->pname = trim($this->groups[$ix][$snum][1]);
					$this->theme = trim($this->groups[$ix][$snum][4]);
					$this->ptype = trim($this->groups[$ix][$snum][5]);
					$this->album = $this->myfunction = trim($this->groups[$ix][$snum][6]);

					$this->meta .= preg_replace("/\1/","\n",trim(stripslashes($this->groups[$ix][$snum][7])));

					list($type,$num) = explode("_",$this->ptype);
					if($type=="gallery")
					{
						if($num=="") $num = 0;
						$meta = explode("~",@file_get_contents("./codes/gallery.txt"));
						$this->meta .= $meta[$num];
					}
					list($title,$pname) = explode("^",trim($this->groups[$ix][$snum][2]));
					$title = stripslashes($title);
					$this->_wcms_['header'] = $this->header = $title;
					$this->parent  = $this->pname;
					$this->submenu = $sectnum;
				}
				list($name1,$sname) = explode(".",$this->groups[$ix][$snum][1]);
				if($sname)
				{
					if(!$parent)
					{
						$subnum = 0;
						$parent = $name1;
					}
					if($this->page==$sectnum)
					{
						$this->submenu = $pnum;
						$this->parent  = $name1;
					}
					$this->subs[$pnum][$subnum] = $this->groups[$ix][$snum];
					$this->subs[$pnum][$subnum][1] = stripslashes($sname);
					$subnum++;
					continue;
				}
				$parent = "";
				$pnum   = $sectnum;
				$snum++;
			}
			if($pset)
			{
				$this->prev = $this->groups[$ix][$curr-1][0];
				if($this->prev) $this->prev = "&#171; <a href='?p=$this->prev'>Previous</a>";
				$this->next = $this->groups[$ix][$curr+1][0];
				if($this->next) $this->next = "<a href='?p=$this->next'>Next</a> &#187;";
			}
			$pset = 0;
		}
	}
	
	/*-------------------\
	| get logging status |
	\-------------------*/
	function getStatus()
	{
		$this->lstatus = "";
		if(!$_REQUEST['generate'] && $_COOKIE[$this->cookie])
		{
			$themes = explode("\n",@file_get_contents("$this->site$this->language/themes"));
			if(!$themes) $themes = explode("\n",@file_get_contents("themes"));

			$this->lstatus .= "<form method='post' action='index.php' >\nTheme: <select name='theme'>\n<option value=''>SELECT</option>";
			$num = count($themes);
			for($ix=0;$ix<$num;$ix++)
			{
				$theme = trim($themes[$ix]);
				if(!$themes[$ix]) continue;
				$this->lstatus .= "<option value='$theme'>$theme</option>\n";
			}
			$this->lstatus .= "</select> <input class='button' type='submit' value='Go' style='width:40px' / >".
					  "</form><a href='?logout' title='Sign out from site: ".$_COOKIE['mysite']."'>Logout</a>".
					  " | <a href='./admin.php'>cPanel</a> |";
		}
	        elseif(!$_REQUEST['generate'])
		{
			$version = @file_get_contents("version");
			$this->lstatus .= "<a href='admin.php?login' title='Login w-CMS Version $version'>Login</a>  |";
		}
		$this->lstatus .= " $this->copyright ";
	}
		
        /*-------------------------------\
        | replace pattern with user data |
        \-------------------------------*/
        function patReplace($pat)
        {
                $functions = array(
                        "image"		=> "getImage"
                );
		
                if(is_array ($this->_wcms_[$pat])) return "INVALID VALUE";

                if(isset($this->_wcms_[$pat])) return $this->_wcms_[$pat];

                if(preg_match("/^(\w+)\s*=\s*(.*)/",$pat,$regs))
                {
                        if($functions[$regs[1]])
			{
				return $this->$functions[$regs[1]]($regs[2]);
			}
                }
                else return "&#123;$pat}";
        }
	
        /*-------------------------\
        | get image from directory |
        \-------------------------*/
	function getImage($album)
	{
		list($album,$photo,$attrs)  = explode(".",$album);
		
		$photos = explode("\n",@file_get_contents("$this->site/$album/photos"));
		list($name,$desc) = explode("|",$photos[$photo]);
		return "<img src='$this->site/$album/$name' title='$desc' $attrs />";
	}
	
	/*------------------\
	| display menu list |
	\------------------*/
	function displayMenu($group,$stag,$etag,$args)
	{
		list($current,$tag1,$tag2,$theme,$start,$end) = explode("^",$args);

		if(!$end) $end  = count($this->groups[$group]);
		if(!$start) $start = 0;

		for($ix=$start;$ix<$end;$ix++)
		{
			$tags = $stag;
			if(!trim($this->groups[$group][$ix][1])) continue;
			list($name,$sub) = explode(".",$this->groups[$group][$ix][1]);
			if($sub) continue;
			
			$pnum = trim($this->groups[$group][$ix][0]);
			$name = stripslashes(trim($this->groups[$group][$ix][1]));

			list($title) = explode("^",trim($this->groups[$group][$ix][2]));
			if($title) $title = " title='$title'";

			if($current)
			{
				if($pnum==$this->page)
				{
					$tags = preg_replace("/current/",$current,$stag);
				}
				else	$tags = preg_replace("/current/","",$stag);
			}
			$nolink = 0;
			if($pnum<0)
			{
				$pnum *= -1;
				$name = "<i>$name</i>";
			}
			if($tag1=="ins")
			{
				$ins = $tag2;
			}
			elseif($tag1)
			{
				if($tag1=="nolink") $nolink++;
				else $name = "$tag1$name$tag2";
			}			
			if($theme) $theme = "&thm=$theme";
			
			$tags .= " href='?p=$pnum$theme' $ins$title>$name $etag \n";
			
			$attrs = stripslashes(trim($this->groups[$group][$ix][3]));
			if($attrs) $tags = preg_replace("/attrs/",$attrs,$tags);

			if($nolink)
			{
				if($pnum==$this->page) $tags = strip_tags($tags,"<li>");
			}
			echo "$tags";
		}
	}
	
	/*-----------------\
	| display sub menu |
	\-----------------*/
	function displaySubMenu($stag,$etag,$args)
	{
		list($current,$tag1,$tag2,$theme,$start,$end) = explode("^",$args);

		$tags  = $stag;
		
		$group = $_REQUEST['g'];
		if(!$group) $group = $this->submenu;
		
		if(!$end) $end  = count($this->subs[$group]);
		if(!$start) $start = 0;
	
		for($ix=$start;$ix<$end;$ix++)
		{
			$pnum = trim($this->subs[$group][$ix][0]);
			$name = trim($this->subs[$group][$ix][1]);

			list($title) = explode("^",trim($this->subs[$group][$ix][2]));
			if($title) $title = " title='$title'";

			if($current)
			{
				if($pnum==$this->page)
				{
					$tags = preg_replace("/current/","$current",$stag);
				}
				else	$tags = preg_replace("/current/","",$stag);
			}
			if($pnum<0)
			{
				$pnum *= -1;
				$name = "<i>$name</i>";
			}
			$attrs = stripslashes(trim($this->subs[$group][$ix][3]));
			if($attrs) $tags = preg_replace("/attrs/",$attrs,$tags);
			
			echo "$tags href='?p=$pnum' $title>$name $etag \n";
		}
	}
	
	/*----------------------------\
	| display menu in tree format |
	\----------------------------*/
	function treeMenu($group,$stag,$etag,$args)
	{
		$gnum = count($group);
		for($jx=0;$jx<$gnum;$jx++)
		{
			if(!$group[$jx][0]) continue;
			$pnum = $group[$jx][0];
			$name = stripslashes($group[$jx][1]);
			if($pnum<0)
			{
				$pnum *= -1;
				$name = "<i>$name</i>";
			}
			$tags = $stag;
			$link = "?p=$pnum";
			list($current,$tag1,$tag2) = explode("^",$args);
			if($current=="sub")
			{
				if($this->subs[$pnum]) $pattern = " &nbsp;&nbsp;&nbsp; <a href='?p=$pnum'>$tag1</a>";
				else $pattern = "";
			}
			elseif($current)
			{
				if($pnum==$this->page)
				{
					$tags = preg_replace("/current/","$current",$stag);
				}
				else	$tags = preg_replace("/current/","",$stag);
			}

			list($title) = explode("^",preg_replace("/\'/","&#39;",$group[$jx][2]));
			if($title) $title = " title='$title'";
			
			$attrs = stripslashes(trim($group[$jx][3]));
			$tags = preg_replace("/attrs/",$attrs,$tags);
			
			echo "$tags href='$link' $title>$name$etag$pattern";
			
			if($this->subs[$pnum])
			{
				echo "\n<ul>\n";
				$this->treeMenu($this->subs[$pnum],$stag,$etag,$args);
				
			}
			echo "</li>\n";
		}
		echo "</ul>\n";
	}
	
	/*--------------\
	| sites listing |
	\--------------*/
	function sitesListing()
	{
		echo "<h3>Sites Listing</h3><ul><li><a href='./main'>main</a> - Main site</li>";
		
		$sites  = explode("\n",@file_get_contents("sites"));
		$nsites = count($sites);
		for($ix=0;$ix<$nsites;$ix++)
		{
			list($name,$desc) = explode("|",$sites[$ix]);
			if(!$name) continue;
			echo "<li><a href='./$name'>$name</a> - $desc</li>";
		}
		echo "</ul>";
	}
	
	/*---------\
	| site map |
	\---------*/
	function siteMap($prefix)
	{
		echo "<h2>Site Map</h2>\n";
		$num = count($this->groups);
		for($ix=0;$ix<$num;$ix++)
		{
			if(!trim($this->groups[$ix][0][0])) continue;

			echo "<h3>Group $ix</h3>\n";
			$this->displayMap($prefix,$this->groups[$ix]);
		}
	}
	
	/*-----------------\
	| display site map |
	\-----------------*/
	function displayMap($prefix,$group)
	{
		echo "<ul>";
		$gnum = count($group);
		for($jx=0;$jx<$gnum;$jx++)
		{
			$pnum = trim($group[$jx][0]);
			if(!$pnum || $pnum<0) continue;
			if($prefix)
			{
				$this->pnum++;
				$link = "$prefix$this->pnum";
			}
			else
			{
				$link = "?p=$pnum";
			}
			list($title) = explode("^",$group[$jx][2]);
			if($group[$jx][4]=="redirect")
			{
				$title .= " - Redirect to ".$group[$jx][5];
			}
			
			echo "<li><a href='$link' title='$title'>".stripslashes($group[$jx][1])."</a>";
			if($this->subs[$pnum])
			{
				$this->displayMap($prefix,$this->subs[$pnum]);
			}
			echo "</li>\n";
		}
		echo "</ul>\n";
	}
	
	/*------------------------\
        | check verification code |
        \------------------------*/
	function checkVerification()
	{
		$verif_box = $_POST['verif_box'];
		// check to see if verificaton code was correct
		$num = md5($verif_box).'a4xn';
		$cok = $_SESSION['rand_number'];
		if($num == $cok)
		{
			// delete the cookie so it cannot sent again by refreshing this page
			$_SESSION['rand_number'] = "";
			return 0;
		}
		return 1;
	}
	
	/*-------------------\
	| verification image |
	\-------------------*/
	function vfyImage()
	{
		header('Content-type: image/jpeg');

		$width  = 50;
		$height = 24;

		$my_image = imagecreatetruecolor($width, $height);

		imagefill($my_image, 0, 0, 0xFFFFFF);

                // add noise
		for ($c = 0; $c < 40; $c++)
		{
			$x = rand(0,$width-1);
			$y = rand(0,$height-1);
			imagesetpixel($my_image, $x, $y, 0x000000);
		}

		$x = rand(1,10);
		$y = rand(1,10);

		$rand_string = rand(1000,9999);
		imagestring($my_image, 5, $x, $y, $rand_string , 0x000000);
		$_SESSION['rand_number'] = md5($rand_string).'a4xn';

		imagejpeg($my_image);
		imagedestroy($my_image);

		exit;
	}
	
        /*------------------\
        | process templates |
        \------------------*/
	function procTemplates()
	{
		include_once ('designs.php');
		$designer = @file_get_contents("$this->site/designer");
		if(file_get_contents("$this->site/designer") == "designers") $site = "public";
		else $site = $this->site;
		$this->designs = new designFunctions($site,$this->page);
	}
	
        /*--------------\
        | process forum |
        \--------------*/
	function procForum($forum)
	{
		include_once ('forum.php');
		$this->forum = new forumFunctions($forum,$this->site,$this->page,$this->_wcms_);
		
		echo $this->forum->_wcms_['content'];
	}
	
        /*------------------\
        | process guestbook |
        \------------------*/
	function procGuestbook()
	{
		include_once ('guestbook.php');
		$this->guestbook = new guestbookFunctions($this->site,$this->_wcms_);
		
		echo $this->guestbook->_wcms_['content'];
	}
	
        /*-------------\
        | process blog |
        \-------------*/
	function procBlog()
	{
		include_once ('blog.php');
		$this->blog = new blogFunctions($this->site,$this->ptype,$this->_wcms_);

		echo $this->blog->_wcms_['content'];
	}

        /*----------------\
        | process gallery |
        \----------------*/
	function procGallery()
	{
		include_once ('gallery.php');
		$this->gallery = new galleryFunctions($this->site,$this->album,$this->ptype,$this->_wcms_);;
		
		echo $this->gallery->_wcms_['content'];
	}

        /*-------------\
        | process mail |
        \-------------*/
	function procMail()
	{
		include_once ('mail.php');
		$this->mail = new mailFunctions($this->site,$this->_wcms_);
		
		echo $this->mail->_wcms_['content'];
	}
	
        /*----------------\
        | latest activity |
        \----------------*/
	function latestActivity()
	{
		include_once ('latest.php');
		$this->latest = new activityFunctions($this->site,$this->_wcms_);
		
		echo $this->latest->_wcms_['content'];
	}

        /*--------------\
        | file download |
        \--------------*/
	function fileDownload()
	{
		include_once ('download.php');
		$this->download = new downloadFunctions($this->site,$this->ptype,$this->_wcms_);
		
		echo $this->download->_wcms_['content'];
	}
	
        /*--------------\
        | popup window  |
        \--------------*/
        function popupWindow($url,$width,$height,$title)
        {
		return "<a href='#' onclick=\"OpenNewWindow('$url','$width','$height','Loading');\" > $title </a>";
        }
}
?>