<?php
session_start();

if($_REQUEST['vfy_image']) vfyImage();

switch($_REQUEST['udef']) // user defined function
{
	case 'templates': procTemplates();
	case 'member': procMember();
	case 'mail': procMemberMail();
	case 'activity': procActivity();
}
echo "Function ".$_REQUEST['udef']." not supported!";

function procTemplates()
{
	include_once ('./codes/designs.php');
	echo "<html><head><title>w-CMS - Templates Function</title>\n".
			"<link rel='stylesheet' type='text/css' href='templates/style.css' />\n".
			"<link rel='stylesheet' type='text/css' href='css/menu-edit.css' />\n".
			"</head><body><div>\n";
	
	if($_REQUEST['tpl'])
	{
		$theme = "./templates/".$_REQUEST['designer']."/".$_REQUEST['tpl'];
		if($_COOKIE['wcms'])
		{
			$file = @fopen($_COOKIE['mysite']."/theme", "w");
			if(!$file)
			{
				echo "<div class='error'>*** FATAL *** unable to save theme in ".$_REQUEST['designer']."!</div>".
						"<p>Please make sure read/write permissions are enabled!</p>";
				exit;
			}
			fwrite($file, $theme);
			fclose($file);
		}
		echo "<div class='info'>Your theme is now set to <b>$theme</b>.</div>".
			"<p><input class='button' type='button' value='Close' onclick=\"window.opener.location.href='index.php?site=".
				$_COOKIE['mysite']."';window.close()\">".
			"</p>\n</div></body></html>\n";
		 
		exit;
	}	
	$site = $_REQUEST['s'];
	if(!$site) $site = $_COOKIE['mysite'];
	
	$template = new designFunctions($site,$_REQUEST['p']);
	
	if($template->zfile)
	{
		$imsg = install($template->author,$template->design,1);
	}
	if($template->deleted && $site!="public") $imsg = removeTemplate($template->author,$template->design);

	echo "<p>$imsg</p><p><input class='button' type='button' value='Close' onClick='window.close()'></p>\n</div></body></html>\n";
	exit;
}


function install($author,$design,$move)
{
	if (!is_dir("./templates/$author/")) @mkdir("./templates/$author/", 0755);
	
	if(!is_writable("./templates/$author/"))
	{
		echo "/templates/$author folder is not writable by w-CMS.<br /><br />";
		echo "<div class='error'>Please report this error to your system administrator.</div>";
		exit;
	}
	if($move)
	{
		if(!move_uploaded_file($_FILES['zfile']['tmp_name'], "./templates/$author/$design.zip"))
		{
			echo "<div class='error'>There was an error uploading the file, please report this to your system administrator!</div>";
			exit;
		}
	}
	chdir("./templates/$author/");
	$num = extractZip("$design.zip","","$design/");
	
	return "<div class='info'>$num files uploaded.</div>";
}

function extractZip( $zipFile = '', $dirFromZip = '', $folder )
{
	$zipDir = getcwd() . "/";

	$zip = zip_open($zipDir.$zipFile);
	$num = $folders = 0;
	if ($zip)
	{
		while ($zip_entry = zip_read($zip))
		{
			$completePath = $zipDir . dirname(zip_entry_name($zip_entry));
			$fname = zip_entry_name($zip_entry);
			$completeName = "$zipDir$fname";

			if (zip_entry_open($zip, $zip_entry, "r"))
			{
				$ext = strtolower(substr(strrchr($completeName, '.'), 1));
				if($ext)
				{
					if(!preg_match( "/html|htm|xhtml|xml|txt|js|css|gif|jpg|png|bmp|tif/", $ext)) continue;
				}
				if ($fd = @fopen($completeName, 'w+'))
				{
					if(!$folders)
					{
						echo "<div class='error'>Design files must be in a folder named $folder</div>";
						return 0;
					}
					fwrite($fd, zip_entry_read($zip_entry, zip_entry_filesize($zip_entry)));
					fclose($fd);
				}
				else
				{
					if(!$folders)
					{
						if($folder!=$fname)
						{
							echo "<div class='error'>Incorrect Folder Name Defined ($fname); must name it ($folder)</div>";
							@mkdir("$zipDir$folder", 0777);
							echo "<div class='info'>Manually created folder: $zipDir$folder</div>";
							//return 0;
						}
					}
					@mkdir($completeName, 0777);
					$folders++;
				}
				zip_entry_close($zip_entry);
			}
			$num++;
		}
		zip_close($zip);
	}
	return $num;
}

function removeTemplate($author,$design)
{
	unlink("./templates/$author/$design.zip");
	removeFolder("./templates/$author/$design/");

	return "<div class='info'>Please check your folder ($author) to make sure all the files have been removed.</div>";
}

function removeFolder($folder)
{
	$deleted = 0;
	if (!is_dir($folder))
	{
		echo "<div class='error'>$folder not found!</div>";
	}
	else
	{
		unlinkRecursive($folder);
		$deleted++;
	}		
	if($deleted) echo "<div class='info'>$folder Removed!</div>";
}

function unlinkRecursive($dir)
{
	if(!$dh = @opendir($dir))
	{
		return;
	}
	while (false !== ($obj = readdir($dh)))
	{
		if($obj == '.' || $obj == '..' || $obj=="install.php") 	continue;

		if (!@unlink($dir . '/' . $obj))
		{
			unlinkRecursive($dir.'/'.$obj);
		}
	}
	closedir($dh);
	@rmdir($dir);
	return;
}

function procMember()
{
	include_once ('./codes/members.php');
	echo "<html><head><title>w-CMS - Member Function</title>\n".
			"<link rel='stylesheet' type='text/css' href='templates/style.css' />\n".
			"<link rel='stylesheet' type='text/css' href='css/menu-edit.css' />\n".
			"</head><body><div>\n";
	$members = new membersFunctions("","");
	echo $members->_wcms_['content']."<p><button class='button' onclick='window.opener.location.reload();window.close()'>Close</button></p></div></body></html>";
	exit;
}

function procMemberMail()
{
	include_once ('./codes/members.php');
	echo "<html><head><title>w-CMS - Mail Function</title>\n".
			"<link rel='stylesheet' type='text/css' href='templates/style.css' />\n".
			"<link rel='stylesheet' type='text/css' href='css/menu-edit.css' />\n".
			"</head><body><div>\n";
	$members = new membersFunctions("","");
	echo $members->_wcms_['content']."<p><button class='button' onclick='window.close()'>Close</button></p></div></body></html>";
	exit;
}

function checkVerification()
{
	$verif_box = $_POST['verif_box'];
	// check to see if verificaton code was correct
	$num = md5($verif_box).'a4xn';
	$cok = $_SESSION['rand_number'];
	if($num == $cok)
	{
		// delete the cookie so it cannot sent again by refreshing this page
		$_SESSION['rand_number'] = "";
		return 0;
	}
	return 1;
}
	
function vfyImage()
{
	header('Content-type: image/jpeg');

	$width  = 50;
	$height = 24;

	$my_image = imagecreatetruecolor($width, $height);

	imagefill($my_image, 0, 0, 0xFFFFFF);

        // add noise
	for ($c = 0; $c < 40; $c++)
	{
		$x = rand(0,$width-1);
		$y = rand(0,$height-1);
		imagesetpixel($my_image, $x, $y, 0x000000);
	}

	$x = rand(1,10);
	$y = rand(1,10);

	$rand_string = rand(1000,9999);
	imagestring($my_image, 5, $x, $y, $rand_string , 0x000000);
	$_SESSION['rand_number'] = md5($rand_string).'a4xn';

	imagejpeg($my_image);
	imagedestroy($my_image);

	exit;
}

function procActivity()
{
	$type    = $_REQUEST['type'];
	$content = $_REQUEST['content'];
	$content = preg_replace("/\|/","\0xff ",$content)."\n";
	$data = explode("\n",@file_get_contents("./public/$type"));
	$file = @fopen("./public/$type", "w");
	if($file);
	{
		fwrite($file, $content);
		for($ix=0;$ix<25;$ix++)
		{
			fwrite($file,$data[$ix]."\n");
		}
		fclose($file);
	}

	$data = explode("\n",@file_get_contents("./public/all"));
	$file = @fopen("./public/all", "w");
	if($file);
	{
		fwrite($file, "$type\0xff $content");
		for($ix=0;$ix<25;$ix++)
		{
			fwrite($file,$data[$ix]."\n");
		}
		fclose($file);
	}
	if($type=="design")
	{
		$DESIGNS = new SQLiteDatabase("./public/designs.dbf"); // designs database
		
		$design = sqlite_escape_string($_REQUEST['design']);
		$author = sqlite_escape_string($_REQUEST['author']);
		$desc   = sqlite_escape_string($_REQUEST['desc']);
		$host   = sqlite_escape_string($_REQUEST['host']);
	
		$q = @$DESIGNS->query("SELECT id FROM OST WHERE Author='$author' AND Design='$design'");
		list($id) = $q->fetch();
		if(!$id) 
		{
			$mdate = $_REQUEST['mdate'];
			if(!$mdate) $mdate = date("YmdHi");
			$DESIGNS->query("INSERT INTO OST VALUES(NULL,'$design','$author','','$desc','NULL','0','$mdate')");

			$data = @file_get_contents("http://$host/templates/$author/$design.zip");
			$file = @fopen("./templates/$author/$design.zip", "w");
			if($file);
			{
				fwrite($file, $data);
				fclose($file);
				$imsg = install($author,$design,0);
			}
		}
	}
	echo "<html><head><title>w-CMS - Activity Function</title>\n".
		"<link rel='stylesheet' type='text/css' href='templates/style.css' />\n".
		"<link rel='stylesheet' type='text/css' href='css/menu-edit.css' />\n".
		"</head><body><div>\n".
		"<div class='info'>$type activity added to the latest listing.</div>".
		"$imsg<p><button class='button' onclick='window.close()'>Close</button></p></div></body></html>";
	exit;
}

?>
